// 퓬

// 퓬[hNX
function BattleMode(pcModel, partyModel, npcModel, fieldView, textView, selectionMode, dungeonMode, itemMode) {
	this.pM = pcModel;
	this.partyModel = partyModel;
	this.nM = npcModel;
	this.fieldView = fieldView;
	this.textView = textView;
	this.selectionMode = selectionMode;
	this.dungeonMode = dungeonMode;
	this.itemMode = itemMode;
	this.room = -1;
}

// Jn
BattleMode.prototype.start = function(monster, box) {
	KeyManager_addListener(this);
	this.party = this.partyModel[Party];
	this.ppc = this.partyModel[Party].pc;
	this.box = box;
	if (MusicOn) { musicStop(); }
	if (SeOn) { seSounded("BATTLESTART"); }

	this.mode = 'start';
	this.exp = 0, this.teleport = 0, this.alarm = 0;

	var i;
	this.pcList = new Array(0);
	for (i = 0; i < this.ppc.length; i++) {
		this.pcList[i] = this.ppc[i];
		this.pM[this.ppc[i]].silent = 0;
		this.pM[this.ppc[i]].hide = 0;
		this.pM[this.ppc[i]].acPlus = 0;
		this.pM[this.ppc[i]].sleep = 0;
	}

	this.undecided = new Array(1,1,1,1);

	for (i = 0; i < this.nM.length; i++) {
		this.nM[i].init(0);
	}
	if (monster[0] == 0) { this.monsterSet(); }
	else {
		for (i = 0; i < 4; i++) {
			if (monster[i] > 0) { monsterData(i, monster[i]); }
		}
		this.monsterSet();
	}
	this.monster = this.nM[0].id;
	this.monsterLevel = this.nM[0].level;
	this.npcUndecided();
	this.pcSort();

	this.Initiative = 'none';
	this.textView.alert(29, 24, 1, 'X^[ꂽI');
	this.update(0);
}

// I
BattleMode.prototype.end = function(num) {
	var i, pc;
	if (num == 1 || num == 2) {
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			pc = this.pM[this.ppc[i]];
			pc.acPlus = 0, pc.silent = 0;
			if (pc.state == 2) { pc.state = 0; }
			else if (pc.state == 12) { pc.state = 10; }
			pc.check(this.party.protection);
		}
		this.pcSort();
	}
	KeyManager_removeListener(this);
	if (!this.alarm) { save(this.pM, this.partyModel); }
	if (num == 1 || num == 3) {
		if (this.teleport) {
			this.party.x = dice(1,16) - 1;
			this.party.y = dice(1,16) - 1;
			if (MusicOn) { musicStart("DUNGEON"); }
			this.dungeonMode.onKeyPress('move');
		} else if (this.alarm) {
			var monster = new Array(0,0,0,0);
			this.room = -1;
			this.start(monster, -1);
		} else {
			if (MusicOn) { musicStart("DUNGEON"); }
			this.dungeonMode.onKeyPress('none');
		}
	} else if (num == 2) {
		this.party.bright = 0, this.party.protection = 0;
		this.party.discrimination = 0, this.party.floor = 0;
		this.party.check();
		KeyManager_removeListener(this.dungeonMode);
		gameMode.townMode.start();
	}
}

// X^[̃Zbg
BattleMode.prototype.monsterSet = function() {
	var i, j, tmp, diceNum;

	if (this.nM[0].id == 0) {
		if (this.party.floor == -1) {
			monsterData(0, dice(1,7));
		} else if (this.party.floor == -2) {
			monsterData(0, dice(1,15) + 6);
		} else if (this.party.floor == -3) {
			monsterData(0, dice(1,14) + 21);
		} else if (this.party.floor == -4) {
			monsterData(0, dice(1,8) + 35);
		} else if (this.party.floor == -5) {
			monsterData(0, dice(1,14) + 47);
		} else if (this.party.floor == -6) {
			monsterData(0, dice(1,13) + 61);
		} else if (this.party.floor <= -7 && this.party.floor >= -9) {
			while (true) {
				tmp = dice(1,31) + 70;
				if (tmp != 75) {
					break;
				}
			}
			monsterData(0, tmp);
		} else if (this.party.floor == -10) {
			monsterData(0, dice(1,23) + 85);
		}
	}

	for (i = 0; i < 3; i++) {
		if (this.party.floor == -1) {
			if (i == 0) { break; }
		} else if (this.party.floor == -2) {
			if (i == 1) { break; }
		} else if (this.party.floor == -3) {
			if (i == 2) { break; }
		}
		if (this.nM[i].follow > 0 && dice(1,100) <= this.nM[i].followProb) {
			monsterData(i+1, this.nM[i].follow);
		} else { break; }
	}

	for (i = 0; i < 4; i++) {
		if (this.nM[i].id == 0) { break; }
		tmp = dice(this.nM[i].apDiceNum, this.nM[i].apDice) + this.nM[i].apDicePlus;
		if (this.party.floor == -1) {
			if (tmp > 5) { tmp = 5; }
		} else if (this.party.floor == -2) {
			if (tmp > 6) { tmp = 6; }
		} else if (this.party.floor == -3) {
			if (tmp > 7) { tmp = 7; }
		} else if (this.party.floor == -4) {
			if (tmp > 8) { tmp = 8; }
		} else if (tmp > 9){ tmp = 9; }
		for (j = 1; j < tmp; j++) {
			monsterData(i+j*4, this.nM[i].id);
		}
	}
}

// X^[\
BattleMode.prototype.monsterView = function() {
	var i, j, y = 4, text;

	this.textView.textFrameNonMargin(38, 6);

	var monsterNum, canMove;
	for (i = 0; i < 4; i++) {
		canMove = 0;
		if (this.nM[i].id == 0) { break; }
		if (this.nM[i].sleep == 0) { canMove++; }
		monsterNum = 1;
		for (j = 1; j < 9; j++) {
			if (this.nM[i + j * 4].id == 0) { break; }
			if (this.nM[i + j * 4].sleep == 0) { canMove++; }
			monsterNum++;
		}
		this.textView.write(3, y, hzNum(monsterNum, 1));
		if (this.undecided[i]) {
			if (monsterNum >= 2) {
			text = this.nM[i].noneNames;	
			} else {
			text = this.nM[i].noneName;
			}	
			this.textView.write(5, y, text);
		} else {
			if (monsterNum >= 2) {
			text = this.nM[i].names;
			} else {
			text = this.nM[i].name;
			}
			this.textView.write(5, y, text);
		}
		this.textView.write(32, y, 'i' + hzNum(canMove, 1) + 'j');
		y--;
	}

	this.textView.textSet('center', 38, 33);
}

// sI
BattleMode.prototype.actionSel = function(num) {
	this.clear();
	this.textView.partyStatus();
	this.monsterView();
	this.actionSet();

	var pc = this.pM[this.ppc[this.pcNum]];
	this.textView.textFrameNonMargin(11,11);
	this.textView.write(2,9,'y' + pc.name + 'z');

	this.com = new Array();
	var i, count = 0;

	if (this.pcNum < 3) {
		this.com[count] = 1;
		count++;
	}
	if (pc.pcClass == 3 || pc.pcClass == 7) {
		if (this.pM[this.ppc[this.pcNum]].hide == 0) {
			this.com[count] = 2;
			count++;
		} else if (this.pM[this.ppc[this.pcNum]].hide == 1) {
			this.com[count] = 3;
			count++;
		}
	}
	this.com[count] = 4, count++;
	for (i = 0; i < pc.item.length; i++) {
		if (pc.item[i] > 0) {
			var item = itemData(pc.item[i]);
			if (item[18] >= 1000) {
				this.com[count] = 5;
				count++;
				break;
			}
		}
	}
	if (pc.mSpell[0][0] + pc.mSpell[0][1] + pc.mSpell[0][2] + pc.pSpell[0][0] + pc.pSpell[0][1] + pc.pSpell[0][2] > 0 && !pc.silent && pc.state != 1 && pc.state != 11 && this.Initiative != 'pc') {
		this.com[count] = 6;
		count++;
	}
	if (pc.pcClass == 2 || (pc.pcClass == 4 && pc.level >= 4) || (pc.pcClass == 6 && pc.level >= 9)) {
		this.com[count] = 7;
		count++;
	}
	this.com[count] = 8, count++;
	if (this.pcNum > 0) { this.com[count] = 9, count++; }

	for (i = 0; i < this.com.length; i++) {
		if (this.com[i] == 1) {
			this.textView.write(3, 7-i, '키');
		} else if (this.com[i] == 2) {
			this.textView.write(3, 7-i, 'B');
		} else if (this.com[i] == 3) {
			this.textView.write(3, 7-i, '҂');
		} else if (this.com[i] == 4) {
			this.textView.write(3, 7-i, 'g');
		} else if (this.com[i] == 5) {
			this.textView.write(3, 7-i, 'ACe');
		} else if (this.com[i] == 6) {
			this.textView.write(3, 7-i, '');
		} else if (this.com[i] == 7) {
			this.textView.write(3, 7-i, '􂢂');
		} else if (this.com[i] == 8) {
			this.textView.write(3, 7-i, '');
		} else if (this.com[i] == 9) {
			this.textView.write(3, 7-i, '߂');
		}
	}

	this.textView.textSet(30,31,21);
	this.selectionMode.startNon(this, this.com, 28, 31, num);
}

// s\
BattleMode.prototype.actionSet = function() {
	var i, y, text, kind, level, spell, tmp, item;
	for (i = 0; i < this.pcNum; i++) {
		y = 6-i;
		var pc = this.pM[this.ppc[i]];
		if (pc.action[0] == 1) { text = '키'; }
		else if (pc.action[0] == 2) { text = 'B'; }
		else if (pc.action[0] == 3) { text = '҂'; }
		else if (pc.action[0] == 4) { text = 'g'; }
		else if (pc.action[0] == 5) { text = '@'; }
		else if (pc.action[0] == 6) { text = '@'; }
		else if (pc.action[0] == 7) { text = '􂢂'; }
		if (pc.action[0] == 5 || pc.action[0] == 6) {
			if (pc.action[0] == 5) {
				item = itemData(pc.item[pc.action[1]]);
				tmp = item[18] % 1000;
			} else { tmp = pc.action[1]; }
			if (tmp <= 5) { kind = 2, spell = tmp; }
			else {
				tmp -= 800, kind = Math.floor(tmp / 100);
				tmp = tmp % 100, level = Math.floor(tmp / 10);
				tmp = tmp % 10, spell = tmp;
			}
			if (kind == 0) {
				text += MAGE_SPELL[level][spell];
			} else if (kind == 1) {
				text += PRIEST_SPELL[level][spell];
			} else {
				if (spell == 1) { text += ''; }
				else if (spell == 2) { text += 'Ö'; }
				else if (spell == 3) { text += ''; }
				else if (spell == 4) { text += 'Đ'; }
				else if (spell == 5) { text += 'S'; }
			}
		}
		this.textView.textNonFrame(6,1);
		this.textView.write(0,0,text);
		this.textView.textSet(33,y,y);
	}
}

// pc̕ёւ
BattleMode.prototype.pcSort = function() {
	var i, j, count = 0, tmp;
	var sortList = new Array();

	for (i = 0; i < this.ppc.length; i++) {
		sortList[i] = 0;
		tmp = this.pM[this.ppc[i]];
		for (j = 0; j < tmp.action.length; j++) {
			tmp.action[j] = 0;
		}
		if (tmp.sleep > 0) { tmp.sleep -= dice(1,4) - 1; }
		if (tmp.state == 2 && tmp.sleep <= 0) {
			tmp.state = 0, tmp.sleep = 0;
			tmp.check(this.party.protection);
		} else if (tmp.state == 12 && tmp.sleep <= 0) {
			tmp.state = 10, tmp.sleep = 0;
			tmp.check(this.party.protection);
		}
	}

	for (i = 0; i < this.pcList.length; i++) {
		if (this.pcList[i] == 0) { break; }
		if (!this.pM[this.pcList[i]].cantMove) {
			sortList[count] = this.pcList[i];
			count++;
		}
	}
	for (i = 0; i < this.pcList.length; i++) {
		if (this.pcList[i] == 0) { break; }
		tmp = this.pM[this.pcList[i]].state;
		if (tmp == 2 || tmp == 12) {
			sortList[count] = this.pcList[i];
			count++;
		}
	}
	for (i = 0; i < this.pcList.length; i++) {
		if (this.pcList[i] == 0) { break; }
		tmp = this.pM[this.pcList[i]].state;
		if (tmp == 3 || tmp == 4 || tmp == 13 || tmp == 14) {
			sortList[count] = this.pcList[i];
			count++;
		}
	}
	for (i = 0; i < this.pcList.length; i++) {
		if (this.pcList[i] == 0) { break; }
		tmp = this.pM[this.pcList[i]].state;
		if (tmp == 5 || tmp == 6 || tmp == 7) {
			sortList[count] = this.pcList[i];
			count++;
		}
	}

	for (i = 0; i < this.ppc.length; i++) {
		this.ppc[i] = sortList[i];
	}
}

// npc̕ёւ
BattleMode.prototype.npcSort = function() {
	var i, j, k, end;
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 8; j++) {
			if (this.nM[i + j * 4].id == 0) { break; }
			else if (this.nM[i + j * 4].hp <= 0) {
				end = 0;
				for (k = j+1; k < 9; k++) {
					if (this.nM[i + k * 4].id == 0) {
						end = 1;
						break;
					} else if (this.nM[i + k * 4].hp > 0) {
						npcCopy(i + k * 4, i + j * 4);
						this.nM[i + k * 4].hp = 0;
						break;
					}
				}
				if (end) { break; }
			}
		}
	}
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 9; j++) {
			if (this.nM[i + j * 4].id == 0) { break; }
			else if (this.nM[i + j * 4].hp <= 0) {
				this.nM[i + j * 4].init(0);
			}
		}
	}
	for (i = 0; i < 3; i++) {
		if (this.nM[i].id == 0) {
			for (j = i+1; j < 4; j++) {
				if (this.nM[j].id > 0) {
					for (k = 0; k < 9; k++) {
						if (this.nM[j+k*4].id == 0) {
							break;
						}
						npcCopy(j+k*4, i+k*4);
						this.nM[j+k*4].init(0);
					}
					this.undecided[i] = this.undecided[j];
					break;
				}
			}
		}
	}
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 9; j++) {
			if (this.nM[i + j * 4].id == 0) { break; }
			this.nM[i + j * 4].action = new Array(0,0,0);
			if (this.nM[i + j * 4].sleep > 0) {
				this.nM[i + j * 4].sleep -= dice(1,4) - 1;
				if (this.nM[i + j * 4].sleep < 0) {
					this.nM[i + j * 4].sleep = 0;
				}
			}
		}
	}
}

// npc̕sm`FbN
BattleMode.prototype.npcUndecided = function() {
	var i, lvAverage = 0, tmp = 0, pcClass, bonus = 0;
	for (i = 0; i < this.ppc.length; i++) {
		if (this.ppc[i] == 0) { break; }
		if (!this.pM[this.ppc[i]].cantMove) {
			pcClass = this.pM[this.ppc[i]].pcClass;
			if (pcClass == 1 || pcClass == 4 || pcClass == 5) {
				bonus = 20;
			}
			lvAverage += this.pM[this.ppc[i]].level;
			tmp++;
		}
	}
	lvAverage = Math.floor((lvAverage / tmp) / 3);
	if (lvAverage > 20) { lvAverage = 20; }
	if (this.party.bright > 0) { bonus += 20; }
	var r;
	for (i = 0; i < 4; i++) {
		if (this.party.discrimination) { this.undecided[i] = 0; }
		else {
			r = Math.floor(this.nM[i].level / 2);
			if (r > 20) { r = 20; }
			r = 10 + lvAverage + bonus - r;
			if (r > 70) { r = 70; }
			else if (r < 10) { r = 10; }
			if (dice(1,100) <= r) {
				this.undecided[i] = 0;
			}
		}
	}
}

// s̃Zbg\[giou\[gj
BattleMode.prototype.actionTurnSort = function() {
	var i, j, tmp, bonus, pc, count = 0;
	this.sortC = new Array(0);
	this.sortO = new Array(0);
	for (i = 0; i < this.ppc.length; i++) {
		if (this.ppc[i] == 0) { break; }
		pc = this.pM[this.ppc[i]];
		if (pc.action[0] == 0) { break; }
		if (pc.abi[4] >= 21) { bonus = -6; }
		else if (pc.abi[4] >= 19) { bonus = -5; }
		else if (pc.abi[4] == 18) { bonus = -4; }
		else if (pc.abi[4] == 17) { bonus = -3; }
		else if (pc.abi[4] == 16) { bonus = -2; }
		else if (pc.abi[4] == 15) { bonus = -1; }
		else if (pc.abi[4] >= 8) { bonus = 0; }
		else if (pc.abi[4] >= 6) { bonus = 1; }
		else if (pc.abi[4] >= 4) { bonus = 2; }
		else { bonus = 3; }
		this.sortC[count] = dice(1,10) + bonus;
		this.sortO[count] = i;
		count++;
	}
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 9; j++) {
			if (this.nM[i + j * 4].id == 0) { break; }
			this.sortC[count] = dice(1,8) + 2;
			this.sortO[count] = 10 + (i * 10) + j;
			count++;
		}
	}
	for (i = 0; i < this.sortC.length-1; i++) {
		for (j = this.sortC.length-1; j > i; j--) {
			if (this.sortC[j] < this.sortC[j-1]) {
				tmp = this.sortC[j];
				this.sortC[j] = this.sortC[j-1];
				this.sortC[j-1] = tmp;
				tmp = this.sortO[j];
				this.sortO[j] = this.sortO[j-1];
				this.sortO[j-1] = tmp;
			}
		}
	}
}

// SŔ
BattleMode.prototype.deadCheck = function() {
	var i, j, k, dead = 0, cMove, state;
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 9; j++) {
			if (this.nM[i + j * 4].id > 0) {
				dead = 1;
				break;
			}
		}
	}
	if (!dead) { return 1; }
	for (i = 0; i < this.ppc.length; i++) {
		if (this.ppc[i] > 0) {
			cMove = this.pM[this.ppc[i]].cantMove;
			state = this.pM[this.ppc[i]].state;
			if (!cMove || state == 2 || state == 12) {
				dead = 0;
				break;
			}
		}
	}
	if (dead) {
		KeyManager_removeListener(this);
		this.dungeonMode.annihilate();
		return 2;
	}
	return 0;
}

// 񕜌
BattleMode.prototype.partyHpPlus = function() {
	var i, j, pc, npc;
	for (i = 0; i < this.ppc.length; i++) {
		if (this.ppc[i] == 0) { break; }
		pc = this.pM[this.ppc[i]];
		pc.hpCtrl(pc.hpPlus);
	}
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 9; j++) {
			npc = this.nM[i + j * 4];
			if (npc.id == 0) { break; }
			if (npc.hp > 0 && npc.hpPlus != 0) {
				npc.hp += npc.hpPlus;
				if (npc.hp > npc.hpMax) { npc.hp = npc.hpMax; }
				else if (npc.hp <= 0) { npc.hp = 1; }
			}
		}
	}
}

// pc̍sI
BattleMode.prototype.nextPc = function(plus) {
	this.pcNum += plus;
	var check = 0;
	if (this.pcNum < 0) { this.pcNum = 0; }
	if (this.pcNum > 5) {
		check = 1;
	} else if(this.ppc[this.pcNum] == 0 || this.pM[this.ppc[this.pcNum]].cantMove) {
		check = 1;
	}
	if (check) {
		this.mode = 'actionSelEnd';
	}
}

// X^[̍s
BattleMode.prototype.npcActionSet = function() {
	var i, j, npc, tmp = 0, pc;
	var lvAverage = 0, silent = 20, sleep = 20, acPlus = 20;
	for (i = 0; i < this.ppc.length; i++) {
		if (this.ppc[i] == 0) { break; }
		pc = this.pM[this.ppc[i]];
		if (!pc.cantMove) {
			lvAverage += this.pM[this.ppc[i]].level;
			tmp++;
		}
		if (pc.state == 2 || pc.state == 12) { sleep -= 5; }
		if (pc.silent == 1) { silent -= 5; }
	}
	if (sleep < 5) { sleep = 5; }
	if (silent < 5) { silent = 5; }
	pc = this.pM[this.ppc[0]];
	if (pc.acPlus > 0) { acPlus -= 5; }
	if (pc.acPlus > 4) { acPlus -= 5; }
	if (pc.acPlus > 8) { acPlus -= 5; }
	if (pc.acPlus > 12) { acPlus -= 5; }
	if (acPlus < 5) { acPlus = 5; }
	lvAverage = Math.floor(lvAverage / tmp);
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 9; j++) {
			npc = this.nM[i + j * 4];
			if (npc.id == 0) { break; }
			if (npc.hp > 0 && npc.sleep <= 0) {
				this.npcActionSet2(i, j, lvAverage, silent, sleep, acPlus);
			}
		}
	}
}

// X^[̍s 2
BattleMode.prototype.npcActionSet2 = function(npcNum, npcNum2, lvAverage, silent, sleep, acPlus) {
	var npc = this.nM[npcNum + npcNum2 * 4];
	var i, j, tmp, r;

	if (npc.run && npc.action[0] == 0) {
		r = 5, tmp = lvAverage - npc.level;
		if (tmp > 0) {
			for (i = 0; i < tmp; i++) {
				r += 5;
				if (r > 55) {
					r = 55;
					break;
				}
			}
		}
		if (npcNum == 0 && this.nM[1].id == 0) {
			if (this.box == 0) {
				r += 30;
			} else { r += 15; }
		}
		if (dice(1,100) <= r) { npc.action[0] = 8; }
	}
	if (npc.call && npc.action[0] == 0) {
		if (this.nM[npcNum+6*4].id == 0) {
			r = 40;
			for (i = 1; i < 6; i++) {
				if (this.nM[npcNum+i*4].id == 0) {
					break;
				} else { r -= 5; }
			}
			if (dice(1,100) <= r) { npc.action[0] = 10; }
		}
	}
	if ((npc.spellM >= 0 || npc.spellP >= 0) && this.Initiative != 'npc' && npc.action[0] == 0) {
		var kind = -1, lv = -1;
		tmp = Math.floor(npc.hpMax / 4);
		j = (npc.dmgDiceNum * npc.dmgDice) * npc.at;
		j = Math.floor(j / 2);
		r = 100 - j;
		if (npc.silent) { r -= 50; }
		if (npc.breath >= 0) {
			if (npc.hp > tmp) { r -= 30; }
			else { r -= 10; }
		}
		if (r > 95 && j <= 2) { r = 95; }
		else if (r > 85) { r = 85; }
		else if (r < 20) { r = 20; }
		if (dice(1,100) <= r) {
			var choice = new Array(0);
			i = 0;
			if (npc.spellP >= 1 && npc.mp[1] > 0 && dice(1,100) <= silent) {
				choice[i] = 1, i++;
			}
			if (npc.spellM >= 2 && npc.mp[2] > 0 && dice(1,100) <= acPlus) {
				choice[i] = 2, i++;
			}
			if (npc.spellM >= 0 && npc.mp[0] > 0 && dice(1,100) <= sleep) {
				choice[i] = 3, i++;
			}
			if (choice.length > 0) {
				i = dice(1, choice.length);
				if (choice[i] == 1) {
					npc.action[0] = 6, npc.action[1] = 910;
				} else if (choice[i] == 2) {
					npc.action[0] = 6, npc.action[1] = 822;
				} else if (choice[i] == 3) {
					npc.action[0] = 6, npc.action[1] = 801;
				}
			} else {
				if (npc.spellM >= 0 && npc.spellP >= 0) {
					kind = dice(1,2) - 1;
				} else if (npc.spellM >= 0) {
					kind = 0;
				} else if (npc.spellP >= 0) {
					kind = 1;
				}
				j = 0;
				if (kind == 0) { j = npc.spellM; }
				else if (kind == 1) { j = npc.spellP; }
				tmp = 100;
				for (i = j; i >= 0; i--) {
					if (npc.mp[i] > 0) {
						lv = i;
						break;
					} else { tmp -= 20; }
				}
			}
			if (npc.action[0] == 0 && kind >= 0 && lv >= 0) {
				r = tmp;
				if (r < 20) { r = 20; }
				if (dice(1,100) <= r) {
					npc.action[0] = 6;
					if (kind == 0 && lv == 0) {
						npc.action[1] = 800;
						this.npcActionSet3(npcNum, npcNum2, 6);
					} else if (kind == 0 && lv == 1) {
						tmp = dice(1,3);
						if (tmp == 1) { npc.action[1] = 811; }
						else { npc.action[1] = 810; }
					} else if (kind == 0 && lv == 2) {
						tmp = dice(1,2);
						if (tmp == 1) { npc.action[1] = 820; }
						else { npc.action[1] = 821; }
					} else if (kind == 0 && lv == 3) {
						tmp = dice(1,3);
						if (tmp == 1) { npc.action[1] = 830; }
						else if (tmp == 2) { npc.action[1] = 831; }
						else { npc.action[1] = 832; }
					} else if (kind == 0 && lv == 4) {
						tmp = dice(1,2);
						if (tmp == 1) { npc.action[1] = 840; }
						else { npc.action[1] = 841; }
					} else if (kind == 0 && lv == 5) {
						npc.action[1] = 850;
					} else if (kind == 0 && lv == 6) {
						npc.action[1] = 860;
					} else if (kind == 1 && lv == 0) {
						npc.action[1] = 900;
						this.npcActionSet3(npcNum, npcNum2, 6);
					} else if (kind == 1 && lv == 1) {
						npc.action[1] = 911;
						this.npcActionSet3(npcNum, npcNum2, 6);
					} else if (kind == 1 && lv == 2) {
						npc.action[1] = 920;
					} else if (kind == 1 && lv == 3) {
						npc.action[1] = 930;
						this.npcActionSet3(npcNum, npcNum2, 6);
					} else if (kind == 1 && lv == 4) {
						npc.action[1] = 942;
					} else if (kind == 1 && lv == 5) {
						npc.action[1] = 951;
						this.npcActionSet3(npcNum, npcNum2, 6);
					} else if (kind == 1 && lv == 6) {
						npc.action[1] = 961;
					}
				}
			}
		}
	}
	if (npc.breath >= 0 && npc.action[0] == 0) {
		tmp = Math.floor(npc.hpMax / 4);
		if (npc.hp > tmp) { r = 95; }
		else { r = 75; }
		if (dice(1,100) <= r) { npc.action[0] = 9; }
	}
	if (npc.action[0] == 0) {
		tmp = (npc.dmgDiceNum * npc.dmgDice) + npc.dmgDicePlus;
		if (npc.atPlus > 0 || npc.atDrain > 0) { r = 95; }
		else if (npc.spellM == -1 && npc.spellP == -1 && npc.breath == -1) {
			r = 95;
		} else if (tmp > 4) { r = 80; }
		else { r = 20; }
		if (dice(1,100) <= r) {
			npc.action[0] = 1;
			this.npcActionSet3(npcNum, npcNum2, 3);
		} else { npc.action[0] = 4; }
	}
}

// X^[̍s 3
BattleMode.prototype.npcActionSet3 = function(npcNum, npcNum2, num) {
	var npc = this.nM[npcNum + npcNum2 * 4];
	var i, j = 0, pc, count = 0, atPc = new Array(0), tmp;
	npc.action[2] = -1;
	if (num == 3) {
		for (i = 0; i < num; i++) {
			if (this.ppc[i] == 0) { break; }
			pc = this.pM[this.ppc[i]];
			if (pc.cantMove) { break; }
			if (pc.action[0] == 1 && pc.action[2] == npcNum) {
				atPc[count] = i;
				count++;
			}
		}
		if (count > 0 && npcNum2 < 3 && atPc.length > 0) {
			for (i = 0; i < 9; i++) {
				if (this.nM[npcNum+i*4].id == 0) { break; }
				j++;
			}
			if (atPc.length == 3) {
				if (j == 1) {
					tmp = dice(1, atPc.length) - 1;
					npc.action[2] = atPc[tmp];
				} else if (j == 2) {
					if (npcNum2 == 0) {
						tmp = dice(1,2) - 1;
						if (tmp == 1) { tmp++; }
						npc.action[2] = atPc[tmp];
					} else { npc.action[2] = 1; }
				} else {
					npc.action[2] = atPc[npcNum2];
				}
			} else if (atPc.length == 2) {
				if (j == 1) {
					tmp = dice(1, atPc.length) - 1;
					npc.action[2] = atPc[tmp];
				} else if (j == 2) {
					npc.action[2] = atPc[npcNum2];
				} else {
					if (npcNum2 < 2) {
						npc.action[2] = atPc[npcNum2];
					}
				}
			} else if (atPc.length == 1) {
				if (npcNum2 == 0) { npc.action[2] = atPc[0]; }
			}
		}
	}
	if (npc.action[2] == -1) {
		count = 0;
		for (i = 0; i < num; i++) {
			if (this.ppc[i] == 0) { break; }
			pc = this.pM[this.ppc[i]];
			if (pc.state == 5 || pc.state == 6 || pc.state == 7) {
				break;
			}
			count++;
		}
		npc.action[2] = dice(1,count) - 1;
	}
}

// ^[̎s
BattleMode.prototype.turnExe = function() {
	var end, i, j, tmp;
	if (this.target == -1) { this.text2 = '\n\n'; }
	this.viewtext = '';
	end = this.deadCheck();
	if (end == 2) {
		this.mode = 'lose';
		return;
	}
	end = 0;
	if (this.selNum >= this.sortO.length) {
		this.mode = 'actionSel', this.pcNum = 0;
		this.npcSort(), this.npcUndecided(), this.partyHpPlus();
		this.pcSort(), this.Initiative = 'none';
		end = this.deadCheck();
		if (end == 1) { this.mode = 'win'; }
		else if (end == 2) {
			this.mode = 'lose';
			return;
		} else {
			j = 1;
			for (i = 0; i < this.ppc.length; i++) {
				if (this.ppc[i] == 0) { break; }
				tmp = this.pM[this.ppc[i]];
				if (!tmp.cantMove) {
					j = 0;
					break;
				}
			}
			if (j) {
				this.mode = 'actionSelEnd';
				this.enter(0);
			}
		}
		return;
	}
	var next = 0, who = this.sortO[this.selNum];
	var npc = this.nM, pcNum, npcNum, npcNum2, pc, np;
	if (who < 10) {
		pcNum = who, pc = this.pM[this.ppc[who]];
		var end2 = 0;
		for (i = 0; i < 4; i++) {
			for (j = 0; j < 9; j++) {
				if (this.nM[i + j * 4].hp > 0) {
					end2 = 1;
					break;
				}
			}
		}
		if (pc.hide == 1 && end2 && this.target == -1) {
			tmp = pc.abi[4] + pc.abi[5];
			tmp += pc.level - this.monsterLevel;
			if (who < 3) {
				if (tmp > 60) { tmp = 60; }
				else if (tmp < 5) { tmp = 5; }
			} else {
				tmp += 20;
				if (tmp > 80) { tmp = 80; }
				else if (tmp < 10) { tmp = 10; }
			}
			if (dice(1,100) > tmp) {
				this.text = pc.name + '@͌B';
				pc.hide = 2;
				end = 1;
			}
		}
		if (pc.cantMove && end == 0) { next = 1; }
		else if (pc.action[0] == 1 && end == 0) {
			if (this.target == -1) {
				this.target = pc.action[2];
				this.target2 = this.pcAttackTargetSet(pcNum);
				npcNum = this.target, npcNum2 = this.target2;
				if (npcNum2 == -1) { next = 1; }
				else {
					this.text = pc.name + '@́@';
					if (this.undecided[npcNum]) {
						this.text += npc[npcNum].noneName;
					} else { this.text += npc[npcNum].name; }
					this.text += attackMessage(pc.weapon);
					if (SeOn) { seSounded("ATTACK"); }
				}
			} else {
				this.pcAtNpc(pc, 0);
				end = 1;
			}
		} else if (pc.action[0] == 2 && end == 0) {
			this.text = pc.name + '@͉BꂽB';
			pc.hide = 1;
			end = 1;
		} else if (pc.action[0] == 3 && end == 0) {
			if (this.target == -1) {
				this.target = pc.action[2];
				npcNum = this.target;
				this.target2 = this.pcAtNpcTarget(npcNum, 0);
				npcNum2 = this.target2;
				if (npcNum2 == -1) { next = 1; }
				else {
					this.text = pc.name + '@́@';
					if (this.undecided[npcNum]) {
						this.text += npc[npcNum].noneName;
					} else { this.text += npc[npcNum].name; }
					this.text += '@ɊPB';
					if (SeOn) { seSounded("ATTACK"); }
				}
			} else {
				this.pcAtNpc(pc, 1);
				end = 1;
			}
		} else if (pc.action[0] == 4 && end == 0) {
			next = 1;
		} else if (pc.action[0] == 5 && end == 0) {
			if (this.target == -1) {
				this.text = pc.name + '@́@';
				var itemNum = pc.item[pc.action[1]];
				var item = itemData(itemNum);
				this.target = item[18] % 1000;
				if (itemNum >= 10000) {
					this.text += 'H' + abbreviation('item', item[2]);
				} else { this.text += item[1]; }
				this.text += '@gB';
				if (dice(1,100) <= item[20]) {
					pc.item[pc.action[1]] = item[21] + 10000;
					item = itemData(pc.item[pc.action[1]]);
					var data = NtoP(item[3]);
					if(!data[pc.pcClass]) {
						pc.itemS[pc.action[1]] = 0;
					}
					pc.check(this.party.protection);
				}
				this.target2 = this.pcSpellTarget(pc, 0);
				if (this.target2 == -1) { end = 1; }
			} else {
				this.pcSpellExe(pc);
				if (this.target2 == 100) { end = 2; }
				else {
					this.target2 = this.pcSpellTarget(pc, this.target2);
					if (this.target2 == -1) { end = 1; }
				}
			}
		} else if (pc.action[0] == 6 && end == 0) {
			if (this.target == -1) {
				this.text = pc.name + '@́@';
				this.target = pc.action[1];
				var kind = 0, lv, spell;
				if (this.target >= 900) { kind = 1; }
				tmp = this.target % 100;
				lv = Math.floor(tmp / 10), spell = tmp % 10;
				if (kind == 0) {
					tmp = MAGE_SPELL[lv][spell];
					pc.mpM[lv]--;
				} else {
					tmp = PRIEST_SPELL[lv][spell];
					pc.mpP[lv]--;
				}
				this.text += tmp + '@̎B';
				if (!pc.silent) {
					if (SeOn) { seSounded("SPELLRECITE"); }
				}
				this.target2 = this.pcSpellTarget(pc, 0);
				if (this.target2 == -1) { end = 1; }
			} else {
				if (pc.silent) {
					this.text2 = 'A͕܂ĂB\n\n';
					this.target2 = -1;
				} else {
					this.pcSpellExe(pc);
					if (this.target2 == 100) { end = 2; }
					else {
						this.target2 = this.pcSpellTarget(pc, this.target2);
					}
				}
				if (end == 0 && this.target2 == -1) { end = 1; }
			}
		} else if (pc.action[0] == 7 && end == 0) {
			this.target = pc.action[2];
			npcNum = this.target;
			i = 0, tmp = 0;
			while (true) {
				npcNum2 = this.pcAtNpcTarget(npcNum, i);
				if (npcNum2 == -1) { break; }
				if (npc[npcNum].type != 9) { break; }
				j = 3 * pc.abi[2];
				j += (pc.level - npc[npcNum].level) * 2;
				if (pc.pcClass != 2) { j -= 10; }
				if (j > 85) { j = 85; }
				else if (j < 20) { j = 20; }
				if (dice(1,100) <= j) {
					npc[npcNum + npcNum2 * 4].hp = 0;
					this.exp += Math.floor(npc[npcNum + npcNum2 * 4].exp / 2);
					tmp++;
				}
				i = npcNum2 + 1;
			}
			this.text = pc.name + '@';
			if (tmp > 0) {
				if (SeOn) { seSounded("ATTACKHIT"); }
				this.text += hzNum(tmp, 0);
				this.text += 'C̖̎􂢂B';
			} else {
				this.text += '􂢂ƂsB';
			}
			end = 1;
		} else if (end == 0) { next = 1; }
	} else {
		npcNum = Math.floor(who / 10) - 1;
		npcNum2 = who % 10;
		np = npc[npcNum + npcNum2 * 4];
		var npcName;
		if (this.undecided[npcNum]) {
			npcName = npc[npcNum].noneName;
		} else { npcName = npc[npcNum].name; }
		if (np.sleep > 0 || np.hp <= 0) { next = 1; }
		else if (np.action[0] == 1) {
			if (this.target == -1) {
				pc = this.pM[this.ppc[np.action[2]]];
				if (pc.state == 5 || pc.state == 6 || pc.state == 7 || pc.hide == 1) { next = 1; }
				else {
					this.text = npcName + '@́@';
					this.text += pc.name + '@';
					this.text += npcAttackMessage();
					this.target = 0;
				}
			} else {
				this.npcAtPc(np);
				end = 1
			}
		} else if (np.action[0] == 6) {
			if (this.target == -1) {
				this.text = npcName + '@́@';
				this.target = np.action[1], j = this.target;
				var kind = 0, lv, spell;
				if (this.target >= 900) { kind = 1; }
				tmp = this.target % 100;
				lv = Math.floor(tmp / 10), spell = tmp % 10;
				if (kind == 0) {
					tmp = MAGE_SPELL[lv][spell];
				} else {
					if (j == 900) { tmp = ''; }
					else if (j == 920) { tmp = ''; }
					else if (j == 930) { tmp = '匸'; }
					else { tmp = PRIEST_SPELL[lv][spell]; }
				}
				np.mp[lv]--;
				this.text += tmp + '@̎B';
				if (!np.silent) {
					if (SeOn) { seSounded("SPELLRECITE"); }
				}
				if (j == 800 || j == 900 || j == 911 || j == 930 || j == 951) {
					pc = this.pM[this.ppc[np.action[2]]];
					if (pc.state == 5 || pc.state == 6 || pc.state == 7) {
						this.target2 = -1;
					} else {
						this.target2 = np.action[2];
					}
				} else {
					this.target2 = this.npcAttackTarget(0);
				}
				if (this.target2 == -1) { end = 1; }
			} else {
				if (np.silent) {
					this.text2 = 'A͕܂ĂB\n\n';
					this.target2 = -1;
				} else {
					this.npcSpellExe(np, npcName);
					j = this.target;
					if (j == 800 || j == 811 || j == 822 || j == 900 || j == 911 || j == 930 || j == 951) {
						this.target2 = -1;
					} else {
						this.target2 = this.npcAttackTarget(this.target2+1);
					}
				}
				if (this.target2 == -1) { end = 1; }
			}
		} else if (np.action[0] == 8) {
			this.text = npcName + '@͓B';
			np.hp = 0;
			end = 1;
		} else if (np.action[0] == 9) {
			if (this.target == -1) {
				this.target = this.npcAttackTarget(0);
				if (this.target == -1) { end = 1; }
				else if (np.breath == -1) { next = 1; }
				else {
					this.text = npcName;
					this.text += '@̓uXfB';
				}
			} else {
				var pcNum = this.target;
				this.npcBreath(np, this.pM[this.ppc[pcNum]]);
				this.target = this.npcAttackTarget(pcNum+1);
				if (this.target == -1) { end = 1; }
			}
		} else if (np.action[0] == 10) {
			if (this.target == -1) {
				this.text = npcName + '@͒ԂĂ񂾁B';
				this.target = 0;
			} else {
				tmp = 0;
				for (i = 0; i < 9; i++) {
					if (this.nM[npcNum+i*4].id == 0) {
						break;
					}
					tmp++;
				}
				j = 30 + (np.level * 4);
				if (j > 90) { j = 90; }
				if (tmp >= 9 || dice(1,100) > j) {
					this.text2 = 'A͂ȂB\n\n';
				} else {
					this.text2 = 'ꂽB\n\n';
					monsterData(npcNum+tmp*4, np.id);
					var np2 = this.nM[npcNum+tmp*4];
					np2.silent = np.silent;
					np2.breath = np.breath;
					np2.noSpell = np.noSpell;
				}
				end = 1;
			}
		} else { next = 1; }
	}
	if (next) {
		this.selNum++, this.target = -1, this.target2 = -1;
		this.turnExe();
	} else if (end == 1) {
		this.selNum++, this.target = -1, this.target2 = -1;
	}
}

// npc̎gp
BattleMode.prototype.npcSpellExe = function(npc, npcName) {
	var i, j, tmp, pc, sp = this.target, resistR;
	var resistBonus, noSpell = 0, lvBonus;
	var spellDmg, spellRes, spellAli;

	tmp = Math.floor(npc.level / 10) * 0.1;
	if (tmp > 0.5) { tmp = 0.5; }
	resistBonus = 1 - tmp;

	if (sp == 811) {
		npc.ac -= 4;
		this.text2 = npcName + '@̂`bSB\n\n';
	} else if (sp == 822) {
		while (true) {
			pc = this.pM[this.ppc[this.target2]];
			if (pc.sleep > 1) { pc.sleep--; }
			pc.acPlus += 4;
			pc.check(this.party.protection);
			this.target2 = this.npcAttackTarget(this.target2+1);
			if (this.target2 == -1) { break; }
		}
		this.text2 = 'p[eB[S@̂`bSオB\n\n';
	} else if (sp == 801 || sp == 910) {
		pc = this.pM[this.ppc[this.target2]];
		if (pc.sleep > 1) { pc.sleep--; }
		lvBonus = Math.floor(pc.level / 3);
		if (lvBonus > 20) { lvBonus = 20; }
		if (pc.noSpell > 0) {
			noSpell = Math.ceil(pc.noSpell * resistBonus);
			if (noSpell > 95) { noSpell = 95; }
			else if (noSpell < 5) { noSpell = 5; }
		}
		if (View) {
			this.viewtext = npc.name + '@@';
			this.viewtext += pc.name + '@ւ';
			if (sp == 801) { this.viewtext += 'uUv\n'; }
			else if (sp == 910) { this.viewtext += 'uÎv\n'; }
		}
		if (dice(1,100) <= noSpell) {
			this.text2 = pc.name + '@͎זB\n\n';
		} else {
			if (sp == 801) {
				resistR = 3 * pc.abi[1];
			} else if (sp == 910) {
				resistR = 3 * pc.abi[2];
			}
			if (pc.pcClass == 1 || pc.pcClass == 4 || pc.pcClass == 5) {
				resistR += 2 * lvBonus;
			} else {
				resistR += lvBonus;
			}
			if (pc.action[0] == 4) {
				resistR = Math.floor(resistR * 1.5);
			}
			resistR = Math.ceil(resistR * resistBonus);
			if (pc.cantMove) { resistR = Math.floor(resistR / 2); }
			if (resistR > 90) { resistR = 90; }
			else if (resistR < 5) { resistR = 5; }
			if (sp == 801) {
				if (pc.resist[5]) { resistR = 100; }
				if (pc.sleep > 0) {
					this.text2 = pc.name;
					this.text2 += '@͖ĂB\n\n';
					if (dice(1,100) > resistR) {
						pc.sleep += dice(3,3);
					}
				} else if (dice(1,100) <= resistR) {
					this.text2 = pc.name;
					this.text2 += '@͖ȂB\n\n';
				} else {
					this.text2 = pc.name;
					this.text2 += '@͖Ă܂B\n\n';
					if (pc.state == 10 || pc.state == 11) {
						pc.state = 12;
						pc.sleep = dice(3,3);
					} else if (pc.state == 0 || pc.state == 1) {
						pc.state = 2;
						pc.sleep = dice(2,3);
					}
					pc.check(this.party.protection);
				}
			} else if (sp == 910) {
				if (pc.resist[4]) { resistR = 100; }
				if (pc.silent) {
					this.text2 = pc.name;
					this.text2 += '@̎͂łɕ܂ĂB\n\n';
				} else if (dice(1,100) <= resistR) {
					this.text2 = 'A' + pc.name;
					this.text2 += '@ɂ͌ȂB\n\n';
				} else {
					this.text2 = pc.name;
					this.text2 += '@͎𕕂܂ꂽB\n\n';
					pc.silent = 1;
				}
			}
		}
		if (View) {
			this.viewtext += '\nF';
			this.viewtext += hzNum(noSpell, 0) + '';
			this.viewtext += '\nRF';
			this.viewtext += hzNum(resistR, 0) + '';
		}
	} else if (sp == 951) {
		pc = this.pM[this.ppc[this.target2]];
		if (pc.sleep > 1) { pc.sleep--; }
		lvBonus = Math.floor(pc.level / 3);
		if (lvBonus > 20) { lvBonus = 20; }
		if (pc.noSpell > 0) {
			noSpell = Math.ceil(pc.noSpell * resistBonus);
			if (noSpell > 95) { noSpell = 95; }
			else if (noSpell < 5) { noSpell = 5; }
		}
		if (View) {
			this.viewtext = npc.name + '@@';
			this.viewtext += pc.name + '@ւ́uv\n';
		}
		if (dice(1,100) <= noSpell) {
			this.text2 = pc.name + '@͎זB\n\n';
		} else {
			resistR = 2 * pc.abi[2];
			if (pc.pcClass == 1 || pc.pcClass == 4 || pc.pcClass == 5) {
				resistR += 2 * lvBonus;
			} else {
				resistR += lvBonus;
			}
			if (pc.resist[3]) { resistR += 20; }
			if (pc.action[0] == 4) {
				resistR = Math.floor(resistR * 1.5);
			}
			resistR = Math.ceil(resistR * resistBonus);
			if (pc.cantMove) { resistR = Math.floor(resistR / 2); }
			if (resistR > 90) { resistR = 90; }
			else if (resistR < 5) { resistR = 5; }
			if (dice(1,100) <= resistR) {
				this.text2 = 'A' + pc.name;
				this.text2 += '@ɂ͌ȂB\n\n';
			} else {
				if (SeOn) { seSounded("ATTACKHIT"); }
				this.text2 = pc.name;
				this.text2 += '@͖ꂽB\n\n';
				tmp = dice(1,8);
				if (tmp < pc.hp) { pc.hp = tmp; }
			}
		}
		if (View) {
			this.viewtext += '\nF';
			this.viewtext += hzNum(noSpell, 0) + '';
			this.viewtext += '\nRF';
			this.viewtext += hzNum(resistR, 0) + '';
		}
	} else {
		pc = this.pM[this.ppc[this.target2]];
		if (pc.sleep > 1) { pc.sleep--; }
		lvBonus = Math.floor(pc.level / 3);
		if (lvBonus > 20) { lvBonus = 20; }
		var dNum = 1, d = 8, atKind;
		var bonus1 = 0, bonus2 = 0;
		if (sp >= 900) {
			resistR = 3 * pc.abi[2];
			atKind = 3
		} else {
			resistR = 3 * pc.abi[1];
			atKind = 0;
		}
		if (pc.pcClass == 1 || pc.pcClass == 4 || pc.pcClass == 5) {
			resistR += 2 * lvBonus;
		} else {
			resistR += lvBonus;
		}
		if (sp == 820) { dNum = 4, d = 6; }
		else if (sp == 821) { dNum = 4, d = 6, atKind = 2; }
		else if (sp == 830) { dNum = 6, d = 6; }
		else if (sp == 831) { dNum = 6, d = 6, atKind = 2; }
		else if (sp == 832) { dNum = 6, d = 6, atKind = 1; }
		else if (sp == 840) { dNum = 8, atKind = 2; }
		else if (sp == 841) { dNum = 8, atKind = 1; }
		else if (sp == 850) { dNum = 10, d = 10, atKind = 1; }
		else if (sp == 860) { dNum = 15, d = 10; }
		else if (sp == 911) { dNum = 2; }
		else if (sp == 920) { dNum = 2, atKind = 0; }
		else if (sp == 930) { dNum = 3; }
		else if (sp == 942) { dNum = 6, d = 6; }
		else if (sp == 961) { dNum = 12, d = 6; }
		if (pc.noSpell > 0) {
			noSpell = Math.ceil(pc.noSpell * resistBonus);
			if (noSpell > 95) { noSpell = 95; }
			else if (noSpell < 5) { noSpell = 5; }
		}
		if (dice(1,100) <= noSpell) {
			this.text2 = pc.name + '@͎זB\n\n';
		} else {
			bonus1 = Math.floor(npc.level / 8);
			bonus2 = Math.floor(npc.level / 10);
			dmg = dice(dNum, d + bonus1) + bonus2;
			spellDmg = dmg;
			if (pc.resist[atKind]) {
				dmg = Math.ceil(dmg / 2), spellAli = 2;
			}
			if (pc.action[0] == 4) {
				resistR = Math.floor(resistR * 1.5);
			}
			resistR = Math.ceil(resistR * resistBonus);
			if (pc.cantMove) { resistR = Math.floor(resistR / 2); }
			if (resistR > 95) { resistR = 95; }
			else if (resistR < 5) { resistR = 5; }
			if (dice(1,100) <= resistR) {
				dmg = Math.ceil(dmg / 2), spellRes = 1;
			}
			this.text2 = pc.name + '@';
			this.text2 += hzNum(dmg, 0) + '̃_[WB\n\n';
			dmg *= -1, pc.hpCtrl(dmg);
			if (SeOn) { seSounded("ATTACKHIT"); }
			if (pc.hp <= 0) {
				this.text2 += pc.name + '@͎񂾁B';
			}
		}
		if (View) {
			this.viewtext = npc.name + '@@';
			this.viewtext += pc.name + '@ւ̃_[W\n';
			this.viewtext += '\nF';
			this.viewtext += hzNum(noSpell, 0) + '';
			this.viewtext += '\nRF';
			this.viewtext += hzNum(resistR, 0) + '';
			this.viewtext += '\n_[WF';
			tmp = dNum + bonus2;
			this.viewtext += hzNum(tmp, 0) + '`';
			tmp = dNum * (d + bonus1) + bonus2;
			this.viewtext += hzNum(tmp, 0);
			this.viewtext += '\n_[WF' + hzNum(spellDmg, 0);
			if (spellRes) {
				this.viewtext += 'iWXgɂ蔼j';
			}
			if (spellAli == 2) {
				this.viewtext += 'iɂ蔼j';
			}
		}
	}
}

// npc̃uXU
BattleMode.prototype.npcBreath = function(np, pc) {
	var dmg = Math.floor(np.hp / 2);
	var breDmg = dmg, breRes, breAli;
	if (pc.sleep > 1) { pc.sleep--; }
	if (pc.resist[np.breath]) {
		dmg = Math.floor(dmg / 2), breAli = 1;
	}
	var i, j, resistR = Math.floor((pc.abi[3] + pc.abi[5]) / 2);
	resistR = 3 * resistR;
	var lvBonus = Math.floor(pc.level / 1.25);
	if (lvBonus > 40) { lvBonus = 40; }
	resistR += lvBonus;
	if (pc.action[0] == 4) { resistR = Math.floor(resistR * 1.5); }
	if (pc.cantMove) { resistR = Math.floor(resistR / 2); }
	if (resistR > 95) { resistR = 95; }
	else if (resistR < 5) { resistR = 5; }
	if (dice(1,100) <= resistR) {
		dmg = Math.floor(dmg / 2), breRes = 1;
	}
	this.text2 = pc.name + '@' + hzNum(dmg, 0) + '̃_[WB\n\n';
	if (SeOn) { seSounded("ATTACKHIT"); }
	dmg *= -1, pc.hpCtrl(dmg);
	if (pc.hp <= 0) { this.text2 += pc.name + '@͎񂾁B'; }
	if (View) {
		this.viewtext = np.name + '@@';
		this.viewtext += pc.name + '@ւ̃uXU\n';
		this.viewtext += '\nRF' + hzNum(resistR, 0) + '';
		this.viewtext += '\n_[WF' + hzNum(breDmg, 0);
		if (breRes) {
			this.viewtext += 'iWXgɂ蔼j';
		}
		if (breAli == 1) {
			this.viewtext += 'iɂ蔼j';
		}
	}
}

// npc̑S̍U̍UΏۂԂ
BattleMode.prototype.npcAttackTarget = function(num) {
	var i, pc, target = -1;
	if (num == -1) { return target; }
	for (i = num; i < this.ppc.length; i++) {
		if (this.ppc[i] == 0) { break; }
		pc = this.pM[this.ppc[i]];
		if (pc.state != 5 && pc.state != 6 && pc.state != 7) {
			target = i;
			break;
		}
	}
	return target;
}

// npcpcU
BattleMode.prototype.npcAtPc = function(np) {
	var i, tmp, successR;
	var pc = this.pM[this.ppc[np.action[2]]];

	if (pc.sleep > 1) { pc.sleep--; }
	var critR = np.level;
	if (critR > 20) { critR = 20; }
	else if (critR < 5) { critR = 5; }
	var hitR = 10 + (np.level + pc.ac) * 5;
	hitR += np.stPlus;
	if (pc.cantMove) { hitR += 20; }
	else if (pc.action[0] == 4) { hitR -= 20; }
	if (pc.hide == 1) { hitR -= 20; }
	if (hitR > 95) { hitR = 95; }
	else if (hitR < 5) { hitR = 5; }

	successR = np.level * 3 + np.at * 2;
	if (successR > 60) { successR = 60; }
	tmp = Math.floor(pc.level / 2);
	if (tmp > 30) { tmp = 30; }
	successR -= tmp;
	if (successR < 5) { successR = 5; }
	tmp = 0;
	if (pc.abi[3] >= 14) { tmp++; }
	if (pc.abi[3] >= 16) { tmp++; }
	if (pc.abi[3] >= 18) { tmp++; }
	if (pc.abi[3] >= 20) { tmp++; }
	if (pc.action[0] == 4) { tmp++; }
	tmp *= 0.1;
	tmp = 1 - tmp;
	successR = Math.floor(successR * tmp);
	if (successR > 60) { successR = 60; }
	else if (successR < 5) { successR = 5; }

	var atNum = 0, dmg = 0, hit;
	var atPlus = NtoP(np.atPlus);
	for (i = 0; i < np.at; i++) {
		hit = 0;
		tmp = dice(1,100);
		if (tmp <= critR) { hit = 1; }
		else if (tmp <= hitR) { hit = 1; }
		if (hit) {
			atNum++;
			tmp = dice(np.dmgDiceNum, np.dmgDice);
			tmp += np.dmgDicePlus;
			dmg += tmp;
		}
	}
	var choice = new Array(0), atSp;
	if (atNum == 0) {
		this.text2 = 'AOꂽB\n\n';
	} else {
		if (pc.cantMove) { dmg *= 2; }
		if (atPlus[4] && !pc.resist[10] && dice(1,100) <= critR) {
			this.text2 = pc.name + '@͎͂˂ꂽI\n\n';
			pc.hpCtrl(-9999);
			if (SeOn) { seSounded("CRITICAL"); }
		} else {
			if (pc.atDef[np.type]) { dmg = Math.floor(dmg / 2); }
			this.text2 = hzNum(atNum, 0) + 'qbgA';
			this.text2 += hzNum(dmg, 0) + '̃_[WB\n\n';
			dmg *= -1, pc.hpCtrl(dmg);
			if (SeOn) { seSounded("ATTACKHIT"); }
			if (pc.hp <= 0) {
				this.text2 += pc.name + '@͎񂾁B';
			} else if ((atPlus[0] || atPlus[1] || atPlus[2] || atPlus[3] || np.atDrain > 0) && dice(1,100) <= successR) {
				tmp = 0;
				if (np.atDrain > 0) { choice[tmp] = 1, tmp++; }
				if (atPlus[3]) { choice[tmp] = 2, tmp++; }
				if (atPlus[2]) { choice[tmp] = 3, tmp++; }
				if (atPlus[1]) { choice[tmp] = 4, tmp++; }
				if (atPlus[0]) { choice[tmp] = 5, tmp++; }
				atSp = dice(1, choice.length) - 1;

				if (choice[atSp] == 1 && !pc.resist[9]) {
					if (pc.level > 0) {
						this.text2 += pc.name + '@' + hzNum(np.atDrain, 0) + 'xꂽI';
						pc.lvDrain(np.atDrain);
					} else {
						this.text2 += pc.name + '@͏łI';
						pc.level = 1;
						pc.hpCtrl(-9999);
						pc.state = 7;
					}
				} else if (choice[atSp] == 2 && !pc.resist[8]) {
					this.text2 += pc.name + '@͐΂ɂȂB';
					if (pc.state >= 10) {
						pc.state = 14;
					} else { pc.state = 4; }
					pc.check(this.party.protection);
				} else if (choice[atSp] == 3 && !pc.resist[7] && pc.state != 4 && pc.state != 14) {
					this.text2 += pc.name + '@͖ჂB';
					if (pc.state >= 10) {
						pc.state = 13;
					} else { pc.state = 3; }
					pc.check(this.party.protection);
				} else if (choice[atSp] == 4 && !pc.resist[6] && pc.state < 10) {
					this.text2 += pc.name + '@͓łB';
					if (pc.state < 10) {
						pc.state += 10;
					}
					pc.check(this.party.protection);
				} else if (choice[atSp] == 5 && !pc.resist[5] && pc.state != 3 && pc.state != 4 && pc.state != 13 && pc.state != 14) {
					this.text2 += pc.name + '@͖Ă܂B';
					if (pc.state >= 10) {
						pc.state = 12;
						pc.sleep = dice(2,3);
					} else {
						pc.state = 2;
						pc.sleep = dice(2,3);
					}
					pc.check(this.party.protection);
				}
			}
		}
	}
	if (View) {
		this.viewtext = np.name + '@@';
		this.viewtext += pc.name + '@ւ̍U\n';
		this.viewtext += '\nNeBJF' + hzNum(critR, 0) + '';
		this.viewtext += '\nF' + hzNum(hitR, 0) + '';
		this.viewtext += '\nőU񐔁F' + hzNum(np.at, 0) + '';
		this.viewtext += '\n񂠂̃_[WF';
		tmp = np.dmgDiceNum + np.dmgDicePlus;
		this.viewtext += hzNum(tmp, 0) + '`';
		tmp = np.dmgDiceNum * np.dmgDice + np.dmgDicePlus;
		this.viewtext += hzNum(tmp, 0);
		this.viewtext += '\n_[WF';
		tmp = np.dmgDiceNum + np.dmgDicePlus;
		this.viewtext += hzNum(tmp, 0) + '`';
		tmp = np.dmgDiceNum * np.dmgDice + np.dmgDicePlus;
		tmp *= np.at;
		this.viewtext += hzNum(tmp, 0);
		if (atPlus[0] || atPlus[1] || atPlus[2] || atPlus[3] || np.atDrain > 0) {
			this.viewtext += '\nUF';
			this.viewtext += hzNum(successR, 0) + '';
		}
		if (choice.length > 0) {
			this.viewtext += '\nU̎ށF';
			if (choice[atSp] == 1) { this.viewtext += 'z'; }
			else if (choice[atSp] == 2) { this.viewtext += 'Ή'; }
			else if (choice[atSp] == 3) { this.viewtext += ''; }
			else if (choice[atSp] == 4) { this.viewtext += ''; }
			else if (choice[atSp] == 5) { this.viewtext += ''; }
		}
	}
}

// pc̎gp
BattleMode.prototype.pcSpellExe = function(pc) {
	var i, tmp, sp = this.target;
	var noSpell, resistR, resistBonus, dmg = 0, npcResist, npcWeak;
	var dNum, d, atKind;
	var lvBonus, abiBonus, classBonus;

	tmp = Math.floor(pc.level / 10) * 0.1;
	if (tmp > 0.5) { tmp = 0.5; }
	resistBonus = 1 - tmp;
	if (sp >= 900) {
		if (pc.pcClass == 2) { classBonus = 5; }
		else if (pc.pcClass == 4) { classBonus = 6; }
		else if (pc.pcClass == 6) { classBonus = 7; }
		else { classBonus = 8; }
		abiBonus = 1;
		if (pc.abi[2] >= 14) { abiBonus += 0.2; }
		if (pc.abi[2] >= 17) { abiBonus += 0.2; }
		if (pc.abi[2] >= 20) { abiBonus += 0.2; }
	} else {
		if (pc.pcClass == 1) { classBonus = 5; }
		else if (pc.pcClass == 4) { classBonus = 6; }
		else if (pc.pcClass == 5) { classBonus = 7; }
		else { classBonus = 8; }
		abiBonus = 1;
		if (pc.abi[1] >= 14) { abiBonus += 0.2; }
		if (pc.abi[1] >= 17) { abiBonus += 0.2; }
		if (pc.abi[1] >= 20) { abiBonus += 0.2; }
	}
	lvBonus = Math.floor(pc.level / classBonus);

	var spellDmg = 0, spellRes = 0, spellAli = 0;
	if (sp == 800 || sp == 810 || sp == 820 || sp == 821 || sp == 830 || sp == 831 || sp == 832 || sp == 840 || sp == 841 || sp == 850 || sp == 860 || sp == 911 || sp == 942 || sp == 961) {
		var npcNum = pc.action[2], npcNum2 = this.target2;
		var npc = this.nM[npcNum + npcNum2 * 4], npcName
		if (sp == 800|| sp == 911) { this.target2 = 9; }
		else { this.target2++; }
		if (this.undecided[npcNum]) { npcName = npc.noneName; }
		else { npcName = npc.name; }
		if (npc.sleep > 1) { npc.sleep--; }
		npcResist = NtoP(npc.resist), npcWeak = NtoP(npc.weak);
		dNum = 1, d = 8, atKind = 0;
		if (sp == 820) { dNum = 4, d = 6; }
		else if (sp == 821) { dNum = 4, d = 6, atKind = 2; }
		else if (sp == 830) { dNum = 6, d = 6; }
		else if (sp == 831) { dNum = 6, d = 6, atKind = 2; }
		else if (sp == 832) { dNum = 6, d = 6, atKind = 1; }
		else if (sp == 840) { dNum = 8, atKind = 2; }
		else if (sp == 841) { dNum = 8, atKind = 1; }
		else if (sp == 850) { dNum = 10, d = 10, atKind = 1; }
		else if (sp == 860) { dNum = 15, d = 10; }
		else if (sp == 911) { dNum = 2, atKind = 3; }
		else if (sp == 942) { dNum = 6, d = 6, atKind = 3; }
		else if (sp == 961) { dNum = 12, d = 6, atKind = 3; }
		noSpell = Math.ceil(npc.noSpell * resistBonus);
		var bonus = Math.floor(lvBonus * abiBonus);
		if (noSpell > 95) { noSpell = 95; }
		if (dice(1,100) <= noSpell) {
			this.text2 = npcName + '@͎זB\n\n';
		} else {
			dmg = dice(dNum, d + lvBonus) + bonus;
			spellDmg = dmg;
			resistR = 3 * npc.level;
			if (npcWeak[atKind]) { dmg *= 2, spellAli = 1; }
			else if (npcResist[atKind]) {
				dmg = Math.ceil(dmg / 2), spellAli = 2;
			}
			if (npc.action[0] == 4) {
				resistR = Math.floor(resistR * 1.5);
			}
			resistR = Math.ceil(resistR * resistBonus);
			if (npc.sleep > 0) { resistR = Math.floor(resistR / 2); }
			if (resistR > 95) { resistR = 95; }
			else if (resistR < 5) { resistR = 5; }
			if (dice(1,100) <= resistR) {
				dmg = Math.ceil(dmg / 2), spellRes = 1;
			}
			this.text2 = npcName + '@';
			this.text2 += hzNum(dmg, 0) + '̃_[WB\n\n';
			npc.hp -= dmg;
			if (SeOn) { seSounded("ATTACKHIT"); }
			if (npc.hp <= 0) {
				this.text2 += npcName + '@͎񂾁B';
				this.exp += npc.exp;
			}
		}
		if (View) {
			this.viewtext = pc.name + '@@';
			this.viewtext += npc.name + '@ւ̃_[W\n';
			this.viewtext += '\nF';
			this.viewtext += hzNum(noSpell, 0) + '';
			this.viewtext += '\nRF';
			this.viewtext += hzNum(resistR, 0) + '';
			this.viewtext += '\n_[WF';
			tmp = dNum + bonus;
			this.viewtext += hzNum(tmp, 0) + '`';
			tmp = dNum * (d + lvBonus) + bonus;
			this.viewtext += hzNum(tmp, 0);
			this.viewtext += '\n_[WF' + hzNum(spellDmg, 0);
			if (spellRes) {
				this.viewtext += 'iWXgɂ蔼j';
			}
			if (spellAli == 1) {
				this.viewtext += 'iɂ{j';
			} else if (spellAli == 2) {
				this.viewtext += 'iɂ蔼j';
			}
		}
	} else if (sp == 801 || sp == 851 || sp == 910) {
		var npcNum = pc.action[2], npcNum2 = this.target2;
		var npc = this.nM[npcNum + npcNum2 * 4], npcName;
		this.target2++;
		if (this.undecided[npcNum]) { npcName = npc.noneName; }
		else { npcName = npc.name; }
		if (npc.sleep > 1) { npc.sleep--; }
		npcResist = NtoP(npc.resist), npcWeak = NtoP(npc.weak);
		noSpell = Math.ceil(npc.noSpell * resistBonus);
		if (noSpell > 95) { noSpell = 95; }
		if (sp == 851) { noSpell = 0; }
		if (View) {
			this.viewtext = pc.name + '@@';
			this.viewtext += npc.name + '@ւ';
			if (sp == 801) { this.viewtext += 'uUv\n'; }
			else if (sp == 851) { this.viewtext += 'uv\n'; }
			else if (sp == 910) { this.viewtext += 'uÎv\n'; }
		}
		if (dice(1,100) <= noSpell) {
			this.text2 = npcName + '@͎זB\n\n';
		} else {
			if (sp == 801) {
				resistR = 4 * npc.level;
				if (npcWeak[4]) {
					resistR = Math.floor(npc.level / 2);
				} else if (npcResist[4]) {
					resistR = 90;
				}
			} else if (sp == 851) {
				resistR = 6 * npc.level;
				if (npcWeak[9]) {
					resistR = Math.floor(npc.level / 2);
				}
			} else if (sp == 910) {
				resistR = 4 * npc.level;
				if (npcWeak[5]) {
					resistR = Math.floor(npc.level / 2);
				}
			}
			if (npc.action[0] == 4) {
				resistR = Math.floor(resistR * 1.5);
			}
			resistR = Math.ceil(resistR * resistBonus);
			if (npc.sleep > 0) {
				resistR = Math.floor(resistR / 2);
			}
			if (resistR > 90) { resistR = 90; }
			else if (resistR < 5) { resistR = 5; }
			if (sp == 801) {
				if (npc.sleep > 0) {
					this.text2 = npcName;
					this.text2 += '@͖ĂB\n\n';
					if (dice(1,100) > resistR) {
						npc.sleep += dice(3,3);
					}
				} else if (dice(1,100) <= resistR) {
					this.text2 = npcName;
					this.text2 += '@͖ȂB\n\n';
				} else {
					this.text2 = npcName;
					this.text2 += '@͖B\n\n';
					npc.sleep = dice(3,3);
				}
			} else if (sp == 851) {
				if (npc.type == 9) { resistR = 100; }
				if (dice(1,100) <= resistR) {
					this.text2 = 'A' + npcName;
					this.text2 += '@ɂ͌ȂB\n\n';
				} else {
					if (SeOn) { seSounded("ATTACKHIT"); }
					this.text2 = npcName;
					this.text2 += '@͎_Ŏ񂾁B\n\n';
					npc.hp = 0, this.exp += npc.exp;
				}
			} else if (sp == 910) {
				if (npc.silent) {
					this.text2 = npcName;
					this.text2 += '@̎͂łɕ܂ĂB\n\n';
				} else if (dice(1,100) <= resistR) {
					this.text2 = 'A' + npcName;
					this.text2 += '@ɂ͌ȂB\n\n';
				} else {
					this.text2 = npcName;
					this.text2 += '@̎𕕂߂B\n\n';
					npc.silent = 1;
				}
			}
		}
		if (View) {
			this.viewtext += '\nF';
			this.viewtext += hzNum(noSpell, 0) + '';
			this.viewtext += '\nRF';
			this.viewtext += hzNum(resistR, 0) + '';
		}
	} else if (sp == 822 || sp == 842 || sp == 852 || sp == 951) {
		var npcNum = pc.action[2], npcNum2 = this.target2;
		var npc, npcName;
		tmp = 0;
		while (true) {
			npc = this.nM[npcNum + npcNum2 * 4];
			if (npc.sleep > 1) { npc.sleep--; }
			npcResist = NtoP(npc.resist), npcWeak = NtoP(npc.weak);
			if (sp == 822 || sp == 842) { npc.ac += 4; }
			else if (sp == 852) {
				resistR = 2 * npc.level;
				if (npcWeak[9]) {
					resistR = Math.floor(npc.level / 2);
				}
				if (npc.action[0] == 4) {
					resistR = Math.floor(resistR * 1.5);
				}
				resistR = Math.ceil(resistR * resistBonus);
				if (npc.sleep > 0) {
					resistR = Math.floor(resistR / 2);
				}
				if (resistR > 75) { resistR = 75; }
				else if (resistR < 5) { resistR = 5; }
				if (npc.type != 9) { resistR = 100; }
				if (dice(1,100) > resistR) {
					npc.hp = 0, this.exp += npc.exp, tmp++;
				}
			} else if (sp == 951) {
				resistR = 3 * npc.level;
				if (npcWeak[3]) {
					resistR = Math.floor(npc.level / 2);
				} else if (npcResist[3]) { resistR += 20; }
				if (npc.action[0] == 4) {
					resistR = Math.floor(resistR * 1.5);
				}
				resistR = Math.ceil(resistR * resistBonus);
				if (npc.sleep > 0) {
					resistR = Math.floor(resistR / 2);
				}
				if (resistR > 90) { resistR = 90; }
				else if (resistR < 5) { resistR = 5; }
			}
			this.target2 = this.pcSpellTarget(pc, npcNum2 + 1);
			if (this.target2 == -1) { break; }
			npcNum = pc.action[2], npcNum2 = this.target2;
		}
		if (this.undecided[npcNum]) { npcName = npc.noneName; }
		else { npcName = npc.name; }
		if (sp == 822) {
			this.text2 = npcName + '@̂`bSオB\n\n';
		} else if (sp == 842) {
			this.text2 = 'ׂẴX^[';
			this.text2 += '@̂`bSオB\n\n';
		} else if (sp == 852) {
			if (tmp == 0) {
				this.text2 = 'ANȂB\n\n';
			} else {
				if (SeOn) { seSounded("ATTACKHIT"); }
				this.text2 = npcName + '@';
				this.text2 += hzNum(tmp, 0) + 'Cj󂵂B\n\n';
			}
		} else if (sp == 951) {
			if (View) {
				this.viewtext = pc.name + '@@';
				this.viewtext += npc.name + '@ւ́uv\n';
			}
			noSpell = Math.ceil(npc.noSpell * resistBonus);
			if (noSpell > 95) { noSpell = 95; }
			if (dice(1,100) <= noSpell) {
				this.text2 = npcName;
				this.text2 += '@͎זB\n\n';
			} else {
				if (dice(1,100) <= resistR) {
					this.text2 = 'A' + npcName;
					this.text2 += '@ɂ͌ȂB\n\n';
				} else {
					if (SeOn) { seSounded("ATTACKHIT"); }
					this.text2 = npcName;
					this.text2 += '@̖B\n\n';
					tmp = dice(1,8);
					if (tmp < npc.hp) { npc.hp = tmp; }
				}
			}
			if (View) {
				this.viewtext += '\nF';
				this.viewtext += hzNum(noSpell, 0) + '';
				this.viewtext += '\nRF';
				this.viewtext += hzNum(resistR, 0) + '';
			}
		}
	} else if (sp == 1 || sp == 2 || sp == 3 || sp == 5 || sp == 900 || sp == 920 || sp == 921 || sp == 930 || sp == 940 || sp == 950 || sp== 960) {
		var tPcNum = this.ppc[this.target2];
		var pc2 = this.pM[tPcNum], oldHp = pc2.hp;
		var pcNum = this.ppc[this.sortO[this.selNum]];
		var selMode = this.selectionMode;

		if (sp == 960) { this.target2++; }
		else { this.target2 = 6; }

		if (sp == 1) { pc2.hpCtrl(dice(1,8)); }
		else if (sp == 2) { pc2.hpCtrl(dice(2,8)); }
		else if (sp == 3) { pc2.hpCtrl(dice(3,8)); }
		else if (sp == 5) { pc2.hpCtrl(9999); }
		else if (sp == 900) { selMode.recoverHp(pcNum, tPcNum, 0); }
		else if (sp == 920) { selMode.recoverHp(pcNum, tPcNum, 1); }
		else if (sp == 921) { selMode.recoverStatus(pcNum, tPcNum, 0); }
		else if (sp == 930) { selMode.recoverStatus(pcNum, tPcNum, 1); }
		else if (sp == 940) { selMode.recoverHp(pcNum, tPcNum, 2); }
		else if (sp == 950) { selMode.recoverHp(pcNum, tPcNum, 3); }
		else if (sp == 960) {
			var hp, classBonus, lvBonus, abiBonus;
			if (pc.pcClass == 2) { classBonus = 5; }
			else if (pc.pcClass == 4) { classBonus = 6; }
			else if (pc.pcClass == 6) { classBonus = 7; }
			else { classBonus = 8; }
			lvBonus = Math.floor(pc.level / classBonus);
			if (pc.abi[2] >= 14) { abiBonus += 0.2; }
			if (pc.abi[2] >= 17) { abiBonus += 0.2; }
			if (pc.abi[2] >= 20) { abiBonus += 0.2; }
			hp = dice(5, 8 + Math.floor(lvBonus * abiBonus));
			pc2.hpCtrl(hp);
		}
		if (sp == 921 || sp == 930) {
			this.text2 = pc2.name + '@͎B\n\n';
		} else {
			if (pc2.hp >= pc2.hpMax) {
				this.text2 = pc2.name + '@͑SB\n\n';
			} else {
				tmp = pc2.hp - oldHp;
				this.text2 = pc2.name + '@' + hzNum(tmp, 0);
				this.text2 += 'A񕜂B\n\n';
			}
		}
	} else if (sp == 811) {
		pc.acPlus += -4, pc.check(this.party.protection);
		this.text2 = pc.name + '@̂`bSB\n\n';
		this.target2++;
	} else if (sp == 902 || sp == 932) {
		var pc2, pcNum = this.target2;
		while (true) {
			pc2 = this.pM[this.ppc[pcNum]];
			if (sp == 902) { pc2.acPlus += -2; }
			else if (sp == 932) { pc2.acPlus += -4; }
			pc2.check(this.party.protection);
			pcNum = this.pcSpellTarget(pc, pcNum + 1);
			if (pcNum == -1) { break; }
		}
		if (sp == 902) {
			this.text2 = 'p[eB[S@̂`bQB\n\n';
		} else if (sp == 932) {
			this.text2 = 'p[eB[S@̂`bSB\n\n';
		}
		this.target2 = 6;
	} else if (sp == 861) {
		this.teleport = 1;
		this.target2 = 100, this.end(1);
	} else if (sp == 952) {
		if (SeOn) { seSounded("SPELLWARP"); }
		pc.pSpell[5][2] = 0, this.target2 = 100, this.end(2);
	} else if (sp == 862) {
		this.target2++;
		if (pc.level < 13) {
			this.text2 = 'ANȂB\n\n';
		} else {
			pc.lvDrain(1);
			pc.check(this.party.protection);
			this.mode = 'variation', this.com = new Array(0);
			var count = 1, check;
			this.com[0] = dice(1,7);
			while (true) {
				this.com[count] = dice(1,7);
				check = 1;
				for (i = 0; i < count; i++) {
					if (this.com[i] == this.com[count]) {
						check = 0;
						break;
					}
				}
				if (check) {
					if (count == 2) { break; }
					count++;
				}
			}
		}
	}
}

// pc̎gpڕWԂ
BattleMode.prototype.pcSpellTarget = function(pc, num) {
	var i, sp = this.target, target = -1;
	if (sp == 800 || sp == 801 || sp == 810 || sp == 820 || sp == 821 || sp == 822 || sp == 830 || sp == 831 || sp == 832 || sp == 840 || sp == 841 || sp == 850 || sp == 851 || sp == 852 || sp == 910 || sp == 911 || sp == 942 || sp == 951) {
		target = this.pcAtNpcTarget(pc.action[2], num);
	} else if (sp == 842 || sp == 860 || sp == 961) {
		for (i = pc.action[2]; i < 4; i++) {
			target = this.pcAtNpcTarget(i, num);
			if (target == -1) {
				pc.action[2]++;
				num = 0;
			} else { break; }
		}
	} else if (sp == 1 || sp == 2 || sp == 3 || sp == 5 || sp == 900 || sp == 920 || sp == 921 || sp == 930 || sp == 940 || sp == 950) {
		var state;
		if (num < 6) {
			state = this.pM[this.ppc[pc.action[2]]].state;
			if (state != 5 && state != 6 && state != 7) {
				target = pc.action[2];
			}
		}
	} else if (sp == 902 || sp == 932 || sp == 960) {
		var state;
		for (i = num; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			state = this.pM[this.ppc[i]].state;
			if (state != 5 && state != 6 && state != 7) {
				target = i;
				break;
			}
		}
	} else if (sp == 811 || sp == 861 || sp == 862 || sp == 952) {
		if (num == 0) { target = 0; }
	} else if (sp == 901 || sp == 922 || sp == 931 || sp == 941) {
		if (pc.action[0] != 6 || !pc.silent) {
			if (sp == 901) {
				if (this.party.bright < 40) {
					this.party.bright = 40;
				}
			} else if (sp == 922) {
				this.party.discrimination = 1;
				this.undecided = new Array(0,0,0,0);
			} else if (sp == 931) {
				this.party.bright = 100;
			} else if (sp == 941) {
				this.party.protection = 1, this.party.check();
			}
		}
	}
	if (pc.silent) { target = 0; }
	return target;
}

// pc̓eUڕWZbg
BattleMode.prototype.pcAttackTargetSet = function(pcNum) {
	var i, pc = this.pM, npc = this.nM;
	var target = pc[this.ppc[pcNum]].action[2], num = 0;
	for (i = 0; i < pcNum; i++) {
		if (pc[this.ppc[i]].action[0] == 1 && pc[this.ppc[i]].action[2] == pc[this.ppc[pcNum]].action[2]) {
			num++;
		}
	}
	var target2 = -1, tmp = 0;
	for (i = 0; i < 9; i++) {
		if (npc[target + i * 4].id == 0) { break; }
		else if (npc[target + i * 4].hp > 0) {
			if (tmp == num) {
				target2 = i;
				break;
			} else { tmp++; }
		}
	}
	if (target2 == -1) {
		for (i = 0; i < 9; i++) {
			if (npc[target + i * 4].id == 0) { break; }
			else if (npc[target + i * 4].hp > 0) {
				target2 = i;
				break;
			}
		}
	}
	return target2;
}

// pcnpcU
BattleMode.prototype.pcAtNpc = function(pc, mode) {
	var npc = this.nM;
	var npcNum = this.target, npcNum2 = this.target2;
	var i, j, tmp, critR, npcName, dmgBonus = 0, hitBonus = 0;

	if (this.undecided[npcNum]) {
		npcName = npc[npcNum].noneName;
	} else { npcName = npc[npcNum].name; }
	if (npc[npcNum + npcNum2 * 4].sleep > 1) {
		npc[npcNum + npcNum2 * 4].sleep--;
	}

	if (pc.pcClass == 0 || pc.pcClass == 7) {
		critR = pc.level;
		if (critR > 20) { critR = 20; }
		for (i = 16; i <= pc.abi[0]; i++) { dmgBonus++; }
	} else if (pc.pcClass == 5 || pc.pcClass == 6) {
		critR = pc.level;
		if (critR > 15) { critR = 15; }
		for (i = 16; i <= pc.abi[0]; i++) { dmgBonus++; }
	} else {
		critR = Math.floor(pc.level / 2);
		if (critR > 10) { critR = 10; }
	}
	for (i = 15; i <= pc.st; i++) { hitBonus += 5; }
	if (critR < 5) { critR = 5; }
	var hitR = (pc.level + npc[npcNum + npcNum2 * 4].ac) * 5;
	hitR += hitBonus;
	if (mode == 1) { hitR += 20; }
	if (npc[npcNum + npcNum2 * 4].sleep > 0) { hitR += 20; }
	else if (npc[npcNum + npcNum2 * 4].action[0] == 4) { hitR -= 20; }
	if (hitR > 95) { hitR = 95; }
	else if (hitR < 5) { hitR = 5; }

	var atNum = 0, dmg = 0, hit, resist, weak;
	weak = NtoP(npc[npcNum].weak);
	if (pc.crit && weak[8]) { critR *= 2; }
	for (i = 0; i < pc.at; i++) {
		hit = 0;
		tmp = dice(1,100);
		if (tmp <= critR && !pc.curse) { hit = 1; }
		else if (tmp <= hitR) { hit = 1; }
		if (hit) {
			atNum++;
			tmp = dice(pc.dmgDiceNum, pc.dmgDice);
			tmp += pc.dmgDicePlus + dmgBonus;
			dmg += tmp;
		}
	}
	if (atNum == 0) { this.text2 = 'AOꂽB\n\n'; }
	else {
		if (pc.doubleAt[npc[npcNum].type]) { dmg *= 2; }
		if (mode == 1 || npc[npcNum + npcNum2 * 4].sleep > 0) {
			dmg *= 2;
		}
		resist = NtoP(npc[npcNum].resist);
		if (pc.crit && !resist[8] && !pc.curse && dice(1,100) <= critR) {
			this.text2 = npcName + '@͎͂˂ꂽI\n\n';
			npc[npcNum + npcNum2 * 4].hp = 0;
			this.exp += npc[npcNum + npcNum2 * 4].exp;
			if (SeOn) { seSounded("CRITICAL"); }
		} else {
			this.text2 = hzNum(atNum, 0) + 'qbgA';
			this.text2 += hzNum(dmg, 0) + '̃_[WB\n\n';
			npc[npcNum + npcNum2 * 4].hp -= dmg;
			if (SeOn) { seSounded("ATTACKHIT"); }
			if (npc[npcNum + npcNum2 * 4].hp <= 0) {
				this.text2 += npcName + '@͎񂾁B';
				this.exp += npc[npcNum + npcNum2 * 4].exp;
			}
		}
	}
	if (View) {
		this.viewtext = pc.name + '@@';
		this.viewtext += npc[npcNum].name;
		if (npc[npcNum + npcNum2 * 4].sleep > 0) {
			this.viewtext += 'ij';
		}
		this.viewtext += '@ւ';
		if (mode == 1) { this.viewtext += 'PU\n'; }
		else { this.viewtext += 'U\n'; }
		this.viewtext += '\nNeBJF' + hzNum(critR, 0) + '';
		this.viewtext += '\nF' + hzNum(hitR, 0) + '';
		this.viewtext += '\nőU񐔁F' + hzNum(pc.at, 0) + '';
		this.viewtext += '\n񂠂̊{_[WF';
		tmp = pc.dmgDiceNum + pc.dmgDicePlus;
		if (mode == 1 || npc[npcNum + npcNum2 * 4].sleep > 0) {tmp*=2;}
		this.viewtext += hzNum(tmp, 0) + '`';
		tmp = pc.dmgDiceNum * pc.dmgDice + pc.dmgDicePlus;
		if (mode == 1 || npc[npcNum + npcNum2 * 4].sleep > 0) {tmp*=2;}
		this.viewtext += hzNum(tmp, 0);
		this.viewtext += '\n_[W{[iXF' + hzNum(dmgBonus, 0);
		this.viewtext += '\n_[WF';
		tmp = pc.dmgDiceNum + pc.dmgDicePlus + dmgBonus;
		if (mode == 1 || npc[npcNum + npcNum2 * 4].sleep > 0) {tmp*=2;}
		this.viewtext += hzNum(tmp, 0) + '`';
		tmp = pc.dmgDiceNum * pc.dmgDice + pc.dmgDicePlus + dmgBonus;
		tmp *= pc.at;
		if (mode == 1 || npc[npcNum + npcNum2 * 4].sleep > 0) {tmp*=2;}
		this.viewtext += hzNum(tmp, 0);
		if (pc.doubleAt[npc[npcNum].type]) {
			this.viewtext += 'i{Łj';
		}
	}
}

// pc̎UڕWԂ
BattleMode.prototype.pcAtNpcTarget = function(npcNum, num) {
	var i, target = -1;
	if (num == -1) { return target; }
	for (i = num; i < 9; i++) {
		if (this.nM[npcNum + i * 4].id == 0) {
			break;
		}
		if (this.nM[npcNum + i * 4].hp > 0) {
			target = i;
			break;
		}
	}
	return target;
}

// 󔠗ppcI\
BattleMode.prototype.boxPcSel = function(num) {
	this.clear();
	var i, lv = 0, pc, text = '̔I@ǂ܂H';
	this.textView.message(39, 34, 'center', text, 'center');
	this.textView.partyStatus();
	this.textView.textFrameNonMargin(11,7);
	this.textView.write(2, 4, 'N');
	if (this.mode == 'boxInspectPcSel') {
		this.textView.write(3, 2, 'ׂ̂H');
	} else if (this.mode == 'boxDisarmPcSel') {
		this.textView.write(3, 2, '㩂ÔH');
	} else if (this.mode == 'boxOpenPcSel') {
		this.textView.write(3, 2, 'ĴH');
	}
	this.textView.textSet(30,32,26);
	this.sortO = new Array(0), this.sortC = new Array(0);
	for (i = 0; i < this.ppc.length; i++) {
		if (this.ppc[i] == 0) { break; }
		if (!this.pM[this.ppc[i]].cantMove) { this.sortC[i] = 1; }
		this.sortO[i] = 1;
	}
	if (this.pcSel == -10) {
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			pc = this.pM[this.ppc[i]];
			if (pc.cantMove) { break; }
			if (pc.pcClass == 3 && pc.level > lv) {
				this.pcSel = i, num = i, lv = pc.level;
			}
		}
	}
	if (this.pcSel == -10) {
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			pc = this.pM[this.ppc[i]];
			if (pc.cantMove) { break; }
			if (pc.pcClass == 7 && pc.level > lv) {
				this.pcSel = i, num = i, lv = pc.level;
			}
		}
	}
	if (this.pcSel == -10) {
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			pc = this.pM[this.ppc[i]];
			if (pc.cantMove) { break; }
			if (pc.level > lv) {
				this.pcSel = i, num = i, lv = pc.level;
			}
		}
	}
	if (num >= this.sortO.length) { num = 0; }
	else if (num < 0) { num = this.sortO.length-1; }
	this.selectionMode.startNon(this, this.sortO, 6, 4, num);
}

// ʃNA
BattleMode.prototype.clear = function() {
	this.fieldView.viewClear();
}

// ʕ\
BattleMode.prototype.update = function(num) {
	var i, j, text, item, pc = this.pM[this.ppc[this.pcNum]];
	if (this.mode == 'actionSel') {
		this.actionSel(num);
	} else if (this.mode == 'monsterSel') {
		this.textView.partyStatus();
		this.actionSet(), this.monsterView();
		i = pc.action[0];
		if (i == 1 || i == 3 || i == 7) {
			this.textView.textFrameNonMargin(11,11);
			if (i == 1) {
				this.textView.write(1, 6, 'ǂ̃O[v');
				this.textView.write(4, 4, '킢܂H');
			} else if (i == 3) {
				this.textView.write(1, 6, 'ǂ̃O[v');
				this.textView.write(2, 4, '҂܂H');
			} else if (i == 7) {
				this.textView.write(1, 6, 'ǂ̃O[v');
				this.textView.write(1, 4, '􂢂܂H');
			}
			this.textView.textSet(30,31,21);
		} else if (i == 5 || i == 6) {
			this.textView.alert(26, 10, 1, 'ǂɎg܂H');
		}
		var choice = new Array(1,1);
		if (this.nM[2].id != 0) { choice[2] = 1; }
		if (this.nM[3].id != 0) { choice[3] = 1; }
		this.selectionMode.startNon(this, choice, 37, 4, num);
	} else if (this.mode == 'pcSel') {
		this.textView.partyStatus();
		this.actionSet(), this.monsterView();
		this.textView.alert(26, 10, 1, 'NɎg܂H');
		this.sortO = new Array(0);
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			this.sortO[i] = 1;
		}
		if (num >= this.sortO.length) { num = this.sortO.length-1; }
		this.selectionMode.startNon(this, this.sortO, 6, 4, num);
	} else if (this.mode == 'itemSel') {
		this.textView.partyStatus();
		this.actionSet(), this.monsterView();
		this.textView.alert(28, 18, 1, 'ǂg܂H');
		this.textView.textFrame(28, 12);
		this.sortO = new Array(0);
		var y = 9;
		j = 0;
		for (i = 0; i < pc.item.length; i++) {
			if (pc.item[i] == 0) { break; }
			item = itemData(pc.item[i]);
			if (item[18] >= 1000) {
				text = itemStr(pc.item[i], pc.itemS[i], pc.alignment, pc.pcClass);
				this.textView.write(4, y, text), y--;
				this.sortO[j] = i+1, j++;
			}
		}
		this.textView.textSet('center', 25, 14);
		this.selectionMode.startNon(this, this.sortO, 23, 10, num);
	} else if (this.mode == 'actionSelEnd') {
		this.clear();
		this.textView.partyStatus();
		this.actionSet();
		this.monsterView();
		this.textView.message(30, 10, 'center', '낵łH\n\n@@키@@@\n@@ŏɖ߂', 'center');
		var choice = new Array(1,1);
		this.selectionMode.startNon(this, choice, 25, 18, num);
	} else if (this.mode == 'turn') {
		this.clear();
		this.textView.message(39, 34, 'center', this.text + '\n\n' + this.text2, 'left');
		if (View && this.viewtext != '') {
			this.textView.message(26, 32, 'center', this.viewtext, 'left');
		}
	} else if (this.mode == 'start2') {
		if (this.Initiative == 'none') {
			var npcName;
			if (this.undecided[0]) {
				npcName = this.nM[0].noneNames;
			} else { npcName = this.nM[0].names; }
			text = 'FDIȁ@' + npcName;
			text += '\n\n@@키\n@@@@';
			this.textView.message(39, 34, 'center', text, 'center');
			var choice = new Array(1,1);
			this.selectionMode.startNon(this, choice, 34, 20, num);
		}
	} else if (this.mode == 'win') {
		if (MusicOn) { musicStop(); }
		if (SeOn) { seSounded("BATTLEWIN"); }
		this.clear();
		var k, exp, tmp = 0, state, pc2;
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			state = this.pM[this.ppc[i]].state;
			if (state == 2) {
				this.pM[this.ppc[i]].state = 0;
				this.pM[this.ppc[i]].check(this.party.protection);
			} else if (state == 12) {
				this.pM[this.ppc[i]].state = 10;
				this.pM[this.ppc[i]].check(this.party.protection);
			}
			if (!this.pM[this.ppc[i]].cantMove) { tmp++; }
		}
		this.exp = Math.floor(this.exp / tmp);
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			pc2 = this.pM[this.ppc[i]];
			if (!pc2.cantMove) {
				pc2.exp += this.exp;
			}
			pc2.check(this.party.protection);
		}
		this.pcSort();
		text = 'co[́A';
		text += hzNum(this.exp, 0) + 'dwo𓾂B'
		this.textView.message(39, 34, 'center', text, 'left');
		if (this.room >= 0) {
			this.dungeonMode.roomCheck[this.room] = 1;
		}
	} else if (this.mode == 'lose') {
		return;
	} else if (this.mode == 'variation') {
		var choice = new Array(0);
		for (i = 0; i < 3; i++) {
			if (this.com[i] == 1) { choice[i] = 'e|[g@@'; }
			else if (this.com[i] == 2) { choice[i] = 'ق点@@@@@'; }
			else if (this.com[i] == 3) { choice[i] = 'p[eB[񕜂@'; }
			else if (this.com[i] == 4) { choice[i] = '͂񕜂@@@@@'; }
			else if (this.com[i] == 5) { choice[i] = '͂𑝑傷@@@@@'; }
			else if (this.com[i] == 6) { choice[i] = 'p[eB[@@@@'; }
			else if (this.com[i] == 7) { choice[i] = '҂𐶂Ԃ点@@@'; }
		}
		this.selectionMode.start(this, choice, 32, 'center', num);
	} else if (this.mode == 'gold') {
		var tmp = 0, gold = 0;
		var point = getItemData('gold', this.monster);
		if (point.length > 0) {
			gold = point[1] - point[0] + 1;
			gold = dice(1, gold) + (point[0] - 1);
		}
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			if (!this.pM[this.ppc[i]].cantMove) { tmp++; }
		}
		gold = Math.floor(gold / tmp);
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			if (!this.pM[this.ppc[i]].cantMove) {
				this.pM[this.ppc[i]].gold += gold;
			}
			this.pM[this.ppc[i]].check(this.party.protection);
		}
		this.clear();
		text = 'co[́A';
		text += hzNum(gold, 0) + 'fo𓾂B'
		this.textView.message(39, 34, 'center', text, 'left');
	} else if (this.mode == 'box') {
		this.clear();
		text = '̔I@ǂ܂H';
		this.textView.message(39, 34, 'center', text, 'center');
		this.com = new Array(0);
		var tmp = 0, pc2;
		this.com[tmp] = 1, tmp++, this.com[tmp] = 2, tmp++;
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			pc2 = this.pM[this.ppc[i]];
			if (pc2.cantMove) { break; }
			if (pc2.pSpell[1][2]) {
				if (pc2.mpP[1] > 0) {
					this.com[tmp] = 3, tmp++;
					break;
				}
			}
		}
		this.com[tmp] = 4, tmp++, this.com[tmp] = 5;
		this.textView.textFrameNonMargin(11,7);
		for (i = 0; i < this.com.length; i++) {
			if (this.com[i] == 1) {
				this.textView.write(3, 5-i, 'ׂ');
			} else if (this.com[i] == 2) {
				this.textView.write(3, 5-i, '㩂O');
			} else if (this.com[i] == 3) {
				this.textView.write(3, 5-i, '̎');
			} else if (this.com[i] == 4) {
				this.textView.write(3, 5-i, 'J');
			} else if (this.com[i] == 5) {
				this.textView.write(3, 5-i, '');
			}
		}
		this.textView.textSet(30,32,26);
		this.selectionMode.startNon(this, this.com, 31, 31, num);
	} else if (this.mode == 'boxInspectPcSel' || this.mode == 'boxDisarmPcSel' || this.mode == 'boxOpenPcSel') {
		this.boxPcSel(num);
	} else if (this.mode == 'boxInspect') {
		this.clear();
		text = abbreviation('trap', this.trapExpect);
		this.textView.message(39, 34, 'center', text, 'center');
		if (View && this.viewtext != '') {
			this.textView.message(26, 30, 'center', this.viewtext, 'left');
		}
	} else if (this.mode == 'boxSeePcSel') {
		this.clear();
		var text = '̔I@ǂ܂H';
		this.textView.message(39, 34, 'center', text, 'center');
		this.textView.partyStatus();
		this.textView.textFrameNonMargin(11,7);
		this.textView.write(2, 5, 'N');
		this.textView.write(3, 3, '̎');
		this.textView.write(4, 1, '̂H');
		this.textView.textSet(30,32,26);
		this.sortO = new Array(0);
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			this.sortO[i] = 1;
		}
		if (num >= this.sortO.length) { num = 0; }
		else if (num < 0) { num = this.sortO.length-1; }
		this.selectionMode.startNon(this, this.sortO, 6, 4, num);
	} else if (this.mode == 'boxSee') {
		this.clear();
		if (dice(1,100) <= 95) {
			this.trapExpect = this.trap;
			text = abbreviation('trap', this.trapExpect);
		} else {
			this.trapExpect = dice(1,10) - 1;
			text = abbreviation('trap', this.trapExpect);
		}
		this.textView.message(39, 34, 'center', text, 'center');
		this.mode = 'boxInspect';
	} else if (this.mode == 'boxDisarm') {
		this.clear();
		text = '̔I@ǂ܂H';
		this.textView.message(39, 34, 'center', text, 'center');
		this.textView.textFrameNonMargin(14,13);
		this.textView.write(2, 11, '㩂́');
		for (i = 1; i <= 9; i++) {
			this.textView.write(3, 10-i, abbreviation('trap', i));
		}
		this.textView.textSet(26,32,20);
		var choice = new Array(1,1,1,1,1,1,1,1,1);
		this.selectionMode.startNon(this, choice, 29, 27, num);
	} else if (this.mode == 'boxOpen') {
		var i, tmp, missR, r, result = 0;
		var pc2 = this.pM[this.ppc[num]];
		this.clear();
		r = Math.floor((pc2.abi[4] + pc2.abi[5]) / 2);
		if (pc2.pcClass == 3) {
			missR = Math.floor((r / 20) * 100);
			if (missR > 95) { missR = 95; }
			else if (missR < 5) { missR = 5; }
			missR = 100 - missR;
			r = (pc2.level + this.party.floor + 45) / 70;
			r = Math.floor(r * 100);
			if (r > 95) { r = 95; }
		} else if (pc2.pcClass == 7) {
			missR = Math.floor((r / 20) * 100);
			if (missR > 90) { missR = 90; }
			else if (missR < 10) { missR = 10; }
			missR = 100 - missR;
			r = (pc2.level + this.party.floor + 40) / 70;
			r = Math.floor(r * 100);
			if (r > 90) { r = 90; }
		} else {
			missR = Math.floor((r / 20) * 100);
			if (missR > 70) { missR = 70; }
			else if (missR < 30) { missR = 30; }
			missR = 100 - missR;
			r = pc2.level + this.party.floor;
			if (r < 1) { r = 1; }
			r = Math.floor((r / 70) * 100);
			if (r > 50) { r = 50; }
		}
		if (this.trap != this.trapExpect) { result = 1; }
		else if (dice(1,100) <= r && this.trap > 0) {
			text = '㩂OB';
		} else if (this.trap > 0) {
			if (dice(1,100) <= missR) { result = 1; }
			else {
				this.mode = 'boxDisarmCancell';
				text = '㩂OȂB';
			}
		}
		if (this.trap == 0) {
			if (this.trapExpect == 0) {
				this.mode = 'itemGet', this.update(0);
				return;
			} else {
				text = '㩂͂ĂȂB';
			}
		} else if (result) {
			text = 'ƁII@';
			text += abbreviation('trap', this.trap);
			if (this.trap == 1) {
				if (pc2.resist[6]) { tmp = pc2.abi[5] * 3; }
				else { tmp = 5; }
				if (pc2.state < 10 && dice(1,100) > tmp) {
					pc2.state += 10;
					pc2.check(this.party.protection);
				}
				if (SeOn) { seSounded("ARROW"); }
			} else if (this.trap == 2) {
				for (i = 0; i < this.ppc.length; i++) {
					if (this.ppc[i] == 0) { break; }
					pc2 = this.pM[this.ppc[i]];
					if (pc2.cantMove) { break; }
					if (pc2.resist[6]) { tmp = 95; }
					else { tmp = pc2.abi[5] * 3; }
					if (dice(1,100) > tmp) {
						if (pc2.state < 10) {
							pc2.state += 10;
							pc2.check(this.party.protection);
						}
					}
				}
				if (SeOn) { seSounded("BOMB"); }
			} else if (this.trap == 3) {
				tmp = dice(5,10) * -1
				pc2.hpCtrl(tmp);
				if (SeOn) { seSounded("ARROW"); }
			} else if (this.trap == 4) {
				for (i = 0; i < this.ppc.length; i++) {
					if (this.ppc[i] == 0) { break; }
					pc2 = this.pM[this.ppc[i]];
					if (pc2.cantMove) { break; }
					tmp = pc2.abi[5] * 3;
					if (dice(1,100) > tmp) {
						tmp = dice(5,10) * -1;
						pc2.hpCtrl(tmp);
					}
				}
				if (SeOn) { seSounded("BOMB"); }
			} else if (this.trap == 5) {
				if (pc2.resist[7]) { tmp = pc2.abi[5] * 3; }
				else { tmp = 5; }
				if (dice(1,100) > tmp) {
					if (pc2.state < 10) { pc2.state = 3; }
					else { pc2.state = 13; }
					pc2.check(this.party.protection);
				}
				if (SeOn) { seSounded("STUN"); }
			} else if (this.trap == 6) {
				this.teleport = 1;
				if (SeOn) { seSounded("SPELLWARP"); }
			} else if (this.trap == 7) {
				for (i = 0; i < this.ppc.length; i++) {
					if (this.ppc[i] == 0) { break; }
					pc2 = this.pM[this.ppc[i]];
					if ((pc2.cantMove && pc2.state != 3 && pc2.state != 13) || (pc2.pcClass != 1 && pc2.pcClass != 4 && pc2.pcClass != 5)) {
						continue;
					}
					if (pc2.state == 3 || pc2.state == 13) {
						if (pc2.resist[8]) { tmp = 95; }
						else { tmp = pc2.abi[5] * 3; }
					} else if (pc2.resist[7]) { tmp = 95; }
					else { tmp = pc2.abi[5] * 3; }
					if (dice(1,100) > tmp) {
						if (pc2.state < 10) {
							if (pc2.state == 3) {
								pc2.state = 4;
							} else {
								pc2.state = 3;
							}
						} else {
							if (pc2.state == 13) {
								pc2.state = 14;
							} else {
								pc2.state = 13;
							}
						}
						pc2.check(this.party.protection);
					}
				}
				if (SeOn) { seSounded("STUN"); }
			} else if (this.trap == 8) {
				for (i = 0; i < this.ppc.length; i++) {
					if (this.ppc[i] == 0) { break; }
					pc2 = this.pM[this.ppc[i]];
					if (pc2.cantMove && pc2.state != 3 && pc2.state != 13 || (pc2.pcClass != 2 && pc2.pcClass != 4 && pc2.pcClass != 6)) {
						continue;
					}
					if (pc2.state == 3 || pc2.state == 13) {
						if (pc2.resist[8]) { tmp = 95; }
						else { tmp = pc2.abi[5] * 3; }
					} else if (pc2.resist[7]) { tmp = 95; }
					else { tmp = pc2.abi[5] * 3; }
					if (dice(1,100) > tmp) {
						if (pc2.state < 10) {
							if (pc2.state == 3) {
								pc2.state = 4;
							} else {
								pc2.state = 3;
							}
						} else {
							if (pc2.state == 13) {
								pc2.state = 14;
							} else {
								pc2.state = 13;
							}
						}
						pc2.check(this.party.protection);
					}
				}
				if (SeOn) { seSounded("STUN"); }
			} else if (this.trap == 9) {
				this.alarm = 1;
				if (SeOn) { seSounded("ALARM"); }
			}
			if (this.trap != 6 && this.trap != 9) {
				this.textView.partyStatus();
			}
			if (this.deadCheck() == 2) { return; }
		}
		this.textView.message(39, 34, 'center', text, 'center');
		if (View) {
			var viewtext;
			if (this.trap != this.trapExpect) {
				r = 0, missR = 100;
			}
			viewtext = '㩂̉F' + hzNum(r, 0) + '';
			viewtext += '\nis㩂̍쓮F' + hzNum(missR, 0) + 'j';
			r = 100 - r;
			missR = missR * r;
			missR = Math.floor(missR / 100);
			if (missR < 1) { missR = 1; }
			viewtext += '\n㩂̍쓮mF' + hzNum(missR, 0) + '';
			this.textView.message(26, 30, 'center', viewtext, 'left');
		}
	} else if (this.mode == 'itemGet') {
		this.clear();
		if (this.item.length == 0) {
			this.mode = 'gold', this.update(0);
			return;
		} else {
			text = '', j = 1;
			var vt = '';
			var tmp, pc2, getItem2, item, text2;
			for (i = 0; i < this.item.length; i += 3) {
				if (View) {
					if (vt == '') {
						vt += 'ACe̓藦\n\n';
					} else { vt += '\n'; }
					vt += hzNum(this.item[i], 0) + '`';
					tmp = this.item[i+1] - this.item[i];
					tmp += this.item[i];
					vt += hzNum(tmp, 0) + 'i';
					vt += hzNum(this.item[i+2], 0);
					vt += 'j';
				}
				if (dice(1,100) <= this.item[i+2]) {
					tmp = this.party.itemGetCheck();
					if (tmp == -1) { break; }
					pc2 = this.pM[this.ppc[tmp]];
					tmp = this.item[i+1] - this.item[i] + 1;
					getItem = dice(1,tmp) + this.item[i] - 1;
					getItem += 10000;
					pc2.getItem(getItem);
					text2 = pc2.name + '@́@';
					item = itemData(getItem);
					text2 += abbreviation('item', item[2]);
					text2 += '@ɓꂽB';
					if (View) {
						vt += 'F' + item[1];
					}
					if (j >= 2) {
						text2 = '\n\n' + text2;
					}
					text += text2;
					j++;
					if (j > 3) { break; }
				}
			}
		}
		if (text != '') {
			this.textView.message(39, 34, 'center', text, 'left');
			if (View) {
				this.textView.message(26, 32, 'center', vt, 'left');
			}
		} else {
			this.mode = 'gold', this.update(0);
			return;
		}
	}
	this.fieldView.update();
}

// E
BattleMode.prototype.rightEnter = function(num) {
	this.update(num);
}

// 
BattleMode.prototype.leftEnter = function(num) {
	this.update(num);
}

// 
BattleMode.prototype.enter = function(num) {
	var i, j, pc = this.pM[this.ppc[this.pcNum]];
	if (this.mode == 'actionSel') {
		pc.action[0] = this.com[num];
		this.selStock = num;
		if (this.com[num] == 1) {
			if (this.nM[1].id == 0) {
				pc.action[2] = 0, this.nextPc(1), num = 0;
			} else {
				this.mode = 'monsterSel', num = 0;
			}
		} else if (this.com[num] == 3) {
			if (this.nM[1].id == 0) {
				pc.action[2] = 0, this.nextPc(1), num = 0;
			} else {
				this.mode = 'monsterSel', num = 0;
			}
		} else if (this.com[num] == 5) {
			this.mode = 'itemSel', num = 0;
		} else if (this.com[num] == 6) {
			this.mode = 'spellSel';
			this.selectionMode.startSpell(this, this.ppc[this.pcNum], 'battle', -1, -1, '', -1);
			this.fieldView.update();
			return;
		} else if (this.com[num] == 7) {
			if (this.nM[1].id == 0) {
				pc.action[2] = 0, this.nextPc(1), num = 0;
			} else {
				this.mode = 'monsterSel', num = 0;
			}
		} else if (this.com[num] == 8) {
			var r = 95;
			if (this.Initiative == 'pc') { r = 100; }
			text = pc.name;
			if (dice(1,100) <= r) {
				this.mode = 'runTrue';
				text += '@͓B\n\n\n\n';
			} else {
				this.mode = 'runFalse';
				text += '@͓ȂB\n\n\n\n';
			}
			this.clear();
			this.textView.message(39, 34, 'center', text, 'left');
		} else if (this.com[num] == 9) { this.nextPc(-1); }
		else { this.nextPc(1); }
		num = 0;
	} else if (this.mode == 'monsterSel' || this.mode == 'pcSel') {
		this.mode = 'actionSel';
		pc.action[2] = num;
		this.nextPc(1);
		num = 0;
	} else if (this.mode == 'itemSel') {
		this.selStock2 = num;
		var item = itemData(pc.item[this.sortO[num] - 1]);
		pc.action[1] = this.sortO[num] - 1;
		i = item[18] % 1000;
		if (i <= 5 || i == 900 || i == 920 || i == 921 || i == 930 || i == 940 || i == 950 || i == 962) {
			this.mode = 'pcSel', num = 0;
		} else if ((i >= 800 && i < 900 && i != 802 && i != 811 && i != 812 && i != 842 && i != 860 && i != 861 && i != 862) || i == 910 || i == 911 || i == 942 || i == 951) {
			if (this.nM[1].id == 0) {
				this.mode = 'actionSel';
				pc.action[2] = 0, this.nextPc(1), num = 0;
			} else {
				this.mode = 'monsterSel', num = 0;
			}
		} else {
			this.mode = 'actionSel', this.nextPc(1), num = 0;
		}
	} else if (this.mode == 'actionSelEnd') {
		if (num == 0) {
			if (this.Initiative != 'pc') { this.npcActionSet(); }
			this.actionTurnSort();
			this.selNum = 0;
			this.mode = 'turn';
			this.target = -1, this.target2 = -1;
			this.turnExe();
			num = 0;
		} else if (num == 1) {
			this.mode = 'actionSel', this.pcNum = 0, num = 0;
		}
	} else if (this.mode == 'start2') {
		if (this.Initiative == 'none') {
			if (num == 0) {
				var pc2;
				for (i = 0; i < this.ppc.length; i++) {
					if (this.ppc[i] == 0) { break; }
					pc2 = this.pM[this.ppc[i]];
					if (!pc2.cantMove && pc2.alignment == 0) {
						if (dice(1,1000) <= 50) {
							pc2.alignment = 2;
							pc2.check(this.party.protection);
						}
					}
				}
				if (this.box == 2) {
					if (MusicOn) { musicStart("BOSS"); }
				} else {
					if (MusicOn) { musicStart("BATTLE"); }
				}
				this.pcNum = 0, this.mode = 'actionSel';
				num = 0;
			} else if (num == 1) {
				var pc2;
				for (i = 0; i < this.ppc.length; i++) {
					if (this.ppc[i] == 0) { break; }
					pc2 = this.pM[this.ppc[i]];
					if (!pc2.cantMove && pc2.alignment == 2) {
						if (dice(1,1000) <= 50) {
							pc2.alignment = 0;
							pc2.check(this.party.protection);
						}
					}
				}
				if (this.room >= 0) {
					this.dungeonMode.roomCheck[this.room] = 1;
				}
				this.end(1);
				return;
			}
		}
	} else if (this.mode == 'variation') {
		var npc, pc2;
		if (this.com[num] == 1) {
			for (i = 0; i < 4; i++) {
				for (j = 0; j < 9; j++) {
					npc = this.nM[i+j*4];
					if (npc.id == 0) { break; }
					if (npc.hp > 0) {
						npc.hp = 0;
						this.exp += npc.exp;
					}
				}
			}
			this.text2 = '͏I\n\n';
		} else if (this.com[num] == 2) {
			for (i = 0; i < 4; i++) {
				for (j = 0; j < 9; j++) {
					npc = this.nM[i+j*4];
					if (npc.id == 0) { break; }
					if (npc.hp > 0) {
						npc.silent = 1;
						npc.breath = -1;
					}
				}
			}
			this.text2 = '͒قII\n\n';
		} else if (this.com[num] == 3) {
			for (i = 0; i < this.ppc.length; i++) {
				if (this.ppc[i] == 0) { break; }
				pc2 = this.pM[this.ppc[i]];
				if (pc2.state != 5 && pc2.state != 6 && pc2.state != 7) {
					pc2.state = 0;
					pc2.hpCtrl(9999);
					pc2.check(this.party.protection);
				}
			}
			this.text2 = 'p[eB[͉񕜂I\n\n';
		} else if (this.com[num] == 4) {
			for (i = 0; i < this.ppc.length; i++) {
				if (this.ppc[i] == 0) { break; }
				pc2 = this.pM[this.ppc[i]];
				for (j = 0; j < pc2.mpM.length; j++) {
					pc2.mpM[j] = pc2.mpMMax[j];
					pc2.mpP[j] = pc2.mpPMax[j];
				}
			}
			this.text2 = 'p[eB[̖͂񕜂I\n\n';
		} else if (this.com[num] == 5) {
			for (i = 0; i < 4; i++) {
				for (j = 0; j < 9; j++) {
					npc = this.nM[i+j*4];
					if (npc.id == 0) { break; }
					if (npc.hp > 0) {
						npc.noSpell = 0;
					}
				}
			}
			this.text2 = 'p[eB[̖͂債I\n\n';
		} else if (this.com[num] == 6) {
			for (i = 0; i < this.ppc.length; i++) {
				if (this.ppc[i] == 0) { break; }
				pc2 = this.pM[this.ppc[i]];
				if (pc2.state != 5 && pc2.state != 6 && pc2.state != 7) {
					pc2.acPlus += -30;
					pc2.check(this.party.protection);
				}
			}
			this.text2 = 'p[eB[͕svcȗ͂ŎꂽI\n\n';
		} else if (this.com[num] == 7) {
			for (i = 0; i < this.ppc.length; i++) {
				if (this.ppc[i] == 0) { break; }
				pc2 = this.pM[this.ppc[i]];
				if (pc2.state == 5 || pc2.state == 6) {
					pc2.state = 0;
					pc2.hpCtrl(9999);
					pc2.check(this.party.protection);
				}
			}
			this.text2 = '҂ԂI\n\n';
		}
		num = 0;
		this.mode = 'turn';
		this.selNum++, this.target = -1, this.target2 = -1;
	} else if (this.mode == 'box') {
		if (this.com[num] == 1) {
			this.mode = 'boxInspectPcSel';
			if (this.pcSel >= 0) { num = this.pcSel; }
			else { num = 0; }
		} else if (this.com[num] == 2) {
			this.mode = 'boxDisarmPcSel';
			if (this.pcSel >= 0) { num = this.pcSel; }
			else { num = 0; }
		} else if (this.com[num] == 3) {
			this.mode = 'boxSeePcSel';
			var pc2;
			for (i = 0; i < this.ppc.length; i++) {
				if (this.ppc[i] == 0) { break; }
				pc2 = this.pM[this.ppc[i]];
				if (pc2.cantMove) { break; }
				if (pc2.pSpell[1][2]) {
					if (pc2.mpP[1] > 0) {
						num = i;
						break;
					}
				}
			}
		} else if (this.com[num] == 4) {
			this.trapExpect = 0;
			this.mode = 'boxOpenPcSel';
			if (this.pcSel >= 0) { num = this.pcSel; }
			else { num = 0; }
		} else if (this.com[num] == 5) {
			this.end(1);
			return;
		}
	} else if (this.mode == 'boxSeePcSel') {
		var pc2 = this.pM[this.ppc[num]];
		if (!pc2.cantMove) {
			if (pc2.pSpell[1][2]) {
				if (pc2.mpP[1] > 0) {
					pc2.mpP[1]--;
					this.mode = 'boxSee';
				}
			}
		}
	} else if (this.mode == 'boxInspectPcSel') {
		var pc2 = this.pM[this.ppc[num]];
		this.viewtext = '';
		if (!pc2.cantMove) {
			this.pcSel = num;
			if (pc2.action[0] >= 0) {
				this.trapExpect = pc2.action[0];
				this.mode = 'boxInspect';
			} else {
				var r, lvBonus = pc2.level * 2;
				if (lvBonus > 26) { lvBonus = 26; }
				r = pc2.abi[4];
				if (pc2.pcClass == 3) {
					r = 20 + r * 3 + lvBonus;
					if (r > 95) { r = 95; }
				} else if (pc2.pcClass == 7) {
					r = 10 + r * 3 + lvBonus;
					if (r > 85) { r = 85; }
				}
				if (View) {
					this.viewtext = '㩂̎ʗF';
					this.viewtext += hzNum(r, 0) + '';
					this.viewtext += '\nʁF';
				}
				if (dice(1,100) <= r) {
					pc2.action[0] = this.trap;
					this.trapExpect = pc2.action[0];
					this.mode = 'boxInspect';
					this.viewtext += '';
				} else {
					pc2.action[0] = dice(1,10) - 1;
					this.trapExpect = pc2.action[0];
					this.mode = 'boxInspect';
					this.viewtext += 's';
				}
			}
		}
	} else if (this.mode == 'boxDisarmPcSel') {
		var pc2 = this.pM[this.ppc[num]];
		if (!pc2.cantMove) {
			this.pcSel = num, this.mode = 'boxDisarm';
			if (this.trapExpect > 0) { num = this.trapExpect - 1; }
			else { num = 0; }
		}
	} else if (this.mode == 'boxDisarm') {
		this.mode = 'boxOpen', this.trapExpect = num + 1;
		num = this.pcSel;
	} else if (this.mode == 'boxOpenPcSel') {
		var pc2 = this.pM[this.ppc[num]];
		if (!pc2.cantMove) {
			this.pcSel = num;
			this.mode = 'boxOpen';
		}
	}
	this.update(num);
}

// LZ
BattleMode.prototype.cancel = function(num) {
	var pc = this.pM[this.ppc[this.pcNum]];
	if (this.mode == 'actionSel') {
		this.nextPc(-1);
		num = 0;
	} else if (this.mode == 'monsterSel') {
		if (pc.action[0] == 1 || pc.action[0] == 3 || pc.action[0] == 7) {
			this.mode = 'actionSel';
			num = this.selStock;
		} else if (pc.action[0] == 5) {
			this.mode = 'itemSel';
			num = this.selStock2;
		} else if (pc.action[0] == 6) {
			this.mode = 'spellSel';
			var tmp = pc.action[1];
			tmp -= 800;
			var kind = Math.floor(tmp / 100);
			tmp = tmp % 100;
			var lv = Math.floor(tmp / 10), sel = tmp % 10;
			this.textView.partyStatus(), this.monsterView();
			this.actionSet();
			this.textView.textNonFrame(14, 5);
			this.textView.textSet(15, 28, 24);
			this.selectionMode.startSpell(this, this.ppc[this.pcNum], 'battle', lv, kind, 'spell', sel);
			this.fieldView.update();
			return;
		}
	} else if (this.mode == 'pcSel') {
		if (pc.action[0] == 5) {
			this.mode = 'itemSel';
			num = this.selStock2;
		} else if (pc.action[0] == 6) {
			this.mode = 'spellSel';
			var tmp = pc.action[1];
			tmp -= 800;
			var kind = Math.floor(tmp / 100);
			tmp = tmp % 100;
			var lv = Math.floor(tmp / 10), sel = tmp % 10;
			this.textView.partyStatus(), this.monsterView();
			this.actionSet();
			this.textView.textNonFrame(14, 5);
			this.textView.textSet(15, 28, 24);
			this.selectionMode.startSpell(this, this.ppc[this.pcNum], 'battle', lv, kind, 'spell', sel);
			this.fieldView.update();
			return;
		}
	} else if (this.mode == 'itemSel' || this.mode == 'spellSel') {
		this.mode = 'actionSel';
		num = this.selStock;
	} else if (this.mode == 'actionSelEnd') {
		this.mode = 'actionSel', this.pcNum = 0, num = 0;
	} else if (this.mode == 'start2') {
		if (this.Initiative == 'none') {
			this.end(1);
			return;
		}
	} else if (this.mode == 'box') {
		this.end(1);
		return;
	} else if (this.mode == 'boxInspectPcSel' || this.mode == 'boxDisarmPcSel' || this.mode == 'boxOpenPcSel' || this.mode == 'boxSeePcSel') {
		this.mode = 'box', num = 0;
	} else if (this.mode == 'boxDisarm') {
		this.mode = 'boxDisarmPcSel';
		num = this.pcSel;
	}
	this.update(num);
}

// L[ꂽƂ
BattleMode.prototype.onKeyPress = function(key) {

	if (key == 'r' || key == 'R') {
		Reset = 1;
		gameMode.init(true);
		return;
	}

	if (this.mode == 'start') {
		if (Frendly(this.party.floor, this.party.x, this.party.y) && this.nM[0].frendly && this.box >= 0) {
			this.clear();
			this.mode = 'start2';
		} else if (dice(1,100) <= 20 && this.box >= 0) {
			this.clear();
			this.mode = 'start2';
			this.Initiative = 'pc';
			var text = 'X^[͂܂ɋCÂĂȂ';
			this.textView.message(39, 34, 'center', text, 'center');
		} else if (dice(1,100) <= 16 && this.box >= 0) {
			this.clear();
			this.mode = 'start2';
			this.Initiative = 'npc';
			var text = 'X^[͓ˑRPĂ';
			this.textView.message(39, 34, 'center', text, 'center');
		} else {
			if (this.box == 2) {
				if (MusicOn) { musicStart("BOSS"); }
			} else {
				if (MusicOn) { musicStart("BATTLE"); }
			}
			this.pcNum = 0, this.mode = 'actionSel';
		}
		this.update(0);
	} else if (this.mode == 'start2') {
		if (this.box == 2) {
			if (MusicOn) { musicStart("BOSS"); }
		} else {
			if (MusicOn) { musicStart("BATTLE"); }
		}
		if (this.Initiative == 'pc') {
			this.mode = 'actionSel';
			this.pcNum = 0;
			this.update(0);
		} else if (this.Initiative == 'npc') {
			this.mode = 'actionSelEnd';
			this.enter(0);
		}
	} else if (this.mode == 'turn') {
		this.turnExe();
		if (this.target2 != 100) { this.update(0); }
	} else if (this.mode == 'win') {
		var i, j = 1, trapNum = 0, pc;
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			pc = this.pM[this.ppc[i]];
			pc.acPlus = 0, pc.silent = 0;
			if (pc.state == 2) {
				pc.state = 0;
			} else if (pc.state == 12) {
				pc.state = 10;
			}
			pc.check(this.party.protection);
		}
		this.pcSort();
		for (i = 0; i < this.ppc.length; i++) {
			if (this.ppc[i] == 0) { break; }
			this.pM[this.ppc[i]].action[0] = -1;
		}
		if (this.box > 0) {
			this.trap = getItemData('trap', this.monster);
			this.item = getItemData('item', this.monster);
			if (this.trap.length == 0) {
				this.mode = 'itemGet';
			} else {
				for (i = 0; i < this.trap.length; i++) {
					trapNum += this.trap[i];
				}
				trapNum = dice(1, trapNum);
				for (i = 0; i < this.trap.length; i++) {
					if (this.trap[i]) {
						if (j == trapNum) {
							this.trap = i;
							break;
						} else { j++; }
					}
				}
				this.nM[0].id = 1, this.pcSel = -10;
				this.trapExpect = -1;
				this.mode = 'box';
			}
		} else {
			this.mode = 'gold';
		}
		this.update(0);
	} else if (this.mode == 'gold') {
		this.end(3);
	} else if (this.mode == 'runTrue') {
		var pre = this.dungeonMode.movePre;
		if (pre == 'forward') {
			if (this.party.direction == 'north') {
				this.party.y = loop(this.party.y-1, MAP_SIZE_Y);
			} else if (this.party.direction == 'east') {
				this.party.x = loop(this.party.x-1, MAP_SIZE_X);
			} else if (this.party.direction == 'south') {
				this.party.y = loop(this.party.y+1, MAP_SIZE_Y);
			} else if (this.party.direction == 'west') {
				this.party.x = loop(this.party.x+1, MAP_SIZE_X);
			}
		} else if (pre == 'left') {
			if (this.party.direction == 'north') {
				this.party.x = loop(this.party.x+1, MAP_SIZE_X);
			} else if (this.party.direction == 'east') {
				this.party.y = loop(this.party.y-1, MAP_SIZE_Y);
			} else if (this.party.direction == 'south') {
				this.party.x = loop(this.party.x-1, MAP_SIZE_X);
			} else if (this.party.direction == 'west') {
				this.party.y = loop(this.party.y+1, MAP_SIZE_Y);
			}
		} else if (pre == 'right') {
			if (this.party.direction == 'north') {
				this.party.x = loop(this.party.x-1, MAP_SIZE_X);
			} else if (this.party.direction == 'east') {
				this.party.y = loop(this.party.y+1, MAP_SIZE_Y);
			} else if (this.party.direction == 'south') {
				this.party.x = loop(this.party.x+1, MAP_SIZE_X);
			} else if (this.party.direction == 'west') {
				this.party.y = loop(this.party.y-1, MAP_SIZE_Y);
			}
		}
		this.end(1);
	} else if (this.mode == 'runFalse') {
		this.mode = 'actionSelEnd';
		this.enter(0);
	} else if (this.mode == 'boxInspect') {
		this.mode = 'box', this.update(0);
	} else if (this.mode == 'boxDisarmCancell') {
		this.mode = 'box', this.update(1);
	} else if (this.mode == 'boxOpen') {
		this.mode = 'itemGet', this.update(0);
	} else if (this.mode == 'itemGet') {
		this.mode = 'gold', this.update(0);
	}
}

